"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _lodash = require("lodash");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _activities = _interopRequireDefault(require("./activities"));

function Activity(_ref) {
  var activity = _ref.activity,
      showDetails = _ref.showDetails,
      showDnbHierarchy = _ref.showDnbHierarchy,
      filter = _ref.filter;
  var ActivityToRender = (0, _lodash.find)(_activities["default"], function (a) {
    return a.canRender(activity, filter);
  });

  if (!ActivityToRender) {
    return null;
  }

  return /*#__PURE__*/_react["default"].createElement(ActivityToRender, {
    activity: activity,
    filter: filter,
    showDetails: showDetails,
    showDnbHierarchy: showDnbHierarchy
  });
}

Activity.propTypes = {
  activity: _propTypes["default"].object.isRequired,
  showDetails: _propTypes["default"].bool,
  showDnbHierarchy: _propTypes["default"].bool,
  filter: _propTypes["default"].array
};
Activity.defaultProps = {
  showDetails: false,
  showDnbHierarchy: false,
  filter: []
};
var _default = Activity;
exports["default"] = _default;