"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _constants = require("@govuk-react/constants");

var _Activity = _interopRequireDefault(require("./Activity"));

var _ActivityFeedHeader = _interopRequireDefault(require("./ActivityFeedHeader"));

var _ActivityFeedFilters = _interopRequireDefault(require("./ActivityFeedFilters"));

var _ActivityFeedShowAll = _interopRequireDefault(require("./ActivityFeedShowAll"));

var _ActivityFeedPagination = _interopRequireDefault(require("./ActivityFeedPagination"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  list-style-type: none;\n  padding: 0;\n  margin-top: ", ";\n\n  & > li {\n    margin-bottom: ", ";\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin: ", " 0;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var ActivityFeedContainer = (0, _styledComponents["default"])('div')(_templateObject(), _constants.SPACING.SCALE_2);
var ActivityFeedCardList = (0, _styledComponents["default"])('ol')(_templateObject2(), _constants.SPACING.SCALE_2, _constants.SPACING.SCALE_2);

var ActivityFeed = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ActivityFeed, _React$Component);

  var _super = _createSuper(ActivityFeed);

  function ActivityFeed(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, ActivityFeed);
    var _props$activityTypeFi = props.activityTypeFilters,
        allActivity = _props$activityTypeFi.allActivity,
        myActivity = _props$activityTypeFi.myActivity,
        externalActivity = _props$activityTypeFi.externalActivity,
        dataHubActivity = _props$activityTypeFi.dataHubActivity;
    _this = _super.call(this, props);
    _this.state = {
      activityTypeFilter: dataHubActivity ? dataHubActivity.value : '',
      showDnbHierarchy: false,
      showDetails: false,
      activityTypeFilters: [allActivity, myActivity, externalActivity, dataHubActivity]
    };
    _this.onActivityTypeFilterChange = _this.onActivityTypeFilterChange.bind((0, _assertThisInitialized2["default"])(_this));
    _this.onShowDetailsClick = _this.onShowDetailsClick.bind((0, _assertThisInitialized2["default"])(_this));
    _this.showActivitiesFromAllCompanies = _this.showActivitiesFromAllCompanies.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(ActivityFeed, [{
    key: "onActivityTypeFilterChange",
    value: function onActivityTypeFilterChange(e) {
      var activityTypeFilter = e.target.value;
      var sendQueryParams = this.props.sendQueryParams;
      var showDnbHierarchy = this.state.showDnbHierarchy;
      sendQueryParams({
        activityTypeFilter: activityTypeFilter,
        showDnbHierarchy: showDnbHierarchy
      });
      this.setState({
        activityTypeFilter: activityTypeFilter
      });
    }
  }, {
    key: "showActivitiesFromAllCompanies",
    value: function showActivitiesFromAllCompanies(e) {
      var showDnbHierarchy = e.target.checked;
      var sendQueryParams = this.props.sendQueryParams;
      var activityTypeFilter = this.state.activityTypeFilter;
      sendQueryParams({
        activityTypeFilter: activityTypeFilter,
        showDnbHierarchy: showDnbHierarchy
      });
      this.setState({
        showDnbHierarchy: showDnbHierarchy
      });
    }
  }, {
    key: "onShowDetailsClick",
    value: function onShowDetailsClick(e) {
      this.setState({
        showDetails: e.target.checked
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          activities = _this$props.activities,
          onLoadMore = _this$props.onLoadMore,
          hasMore = _this$props.hasMore,
          isLoading = _this$props.isLoading,
          actions = _this$props.actions,
          children = _this$props.children,
          totalActivities = _this$props.totalActivities,
          isGlobalUltimate = _this$props.isGlobalUltimate,
          dnbHierarchyCount = _this$props.dnbHierarchyCount,
          isTypeFilterFlagEnabled = _this$props.isTypeFilterFlagEnabled,
          isGlobalUltimateFlagEnabled = _this$props.isGlobalUltimateFlagEnabled;
      var _this$state = this.state,
          activityTypeFilters = _this$state.activityTypeFilters,
          activityTypeFilter = _this$state.activityTypeFilter,
          showDetails = _this$state.showDetails,
          showDnbHierarchy = _this$state.showDnbHierarchy;
      var hasFilters = isTypeFilterFlagEnabled || isGlobalUltimateFlagEnabled;
      return /*#__PURE__*/_react["default"].createElement(ActivityFeedContainer, null, /*#__PURE__*/_react["default"].createElement(_ActivityFeedHeader["default"], {
        totalActivities: totalActivities,
        actions: actions
      }), hasFilters && /*#__PURE__*/_react["default"].createElement(_ActivityFeedFilters["default"], {
        activityTypeFilters: activityTypeFilters,
        activityTypeFilter: activityTypeFilter,
        onActivityTypeFilterChange: this.onActivityTypeFilterChange,
        showActivitiesFromAllCompanies: this.showActivitiesFromAllCompanies,
        isGlobalUltimate: isGlobalUltimate,
        dnbHierarchyCount: dnbHierarchyCount,
        isTypeFilterFlagEnabled: isTypeFilterFlagEnabled,
        isGlobalUltimateFlagEnabled: isGlobalUltimateFlagEnabled
      }), activities.length > 0 && /*#__PURE__*/_react["default"].createElement(_ActivityFeedShowAll["default"], {
        onChange: this.onShowDetailsClick,
        checked: showDetails
      }, "Show details for all activities"), /*#__PURE__*/_react["default"].createElement(ActivityFeedCardList, null, activities.map(function (activity) {
        return /*#__PURE__*/_react["default"].createElement("li", {
          key: activity.id
        }, /*#__PURE__*/_react["default"].createElement(_Activity["default"], {
          activity: activity,
          showDetails: showDetails,
          showDnbHierarchy: showDnbHierarchy
        }));
      })), hasMore && /*#__PURE__*/_react["default"].createElement(_ActivityFeedPagination["default"], {
        isLoading: isLoading,
        onLoadMore: onLoadMore
      }), children);
    }
  }]);
  return ActivityFeed;
}(_react["default"].Component);

exports["default"] = ActivityFeed;
(0, _defineProperty2["default"])(ActivityFeed, "propTypes", {
  onLoadMore: _propTypes["default"].func,
  sendQueryParams: _propTypes["default"].func,
  children: _propTypes["default"].node,
  activities: _propTypes["default"].arrayOf(_propTypes["default"].object),
  activityTypeFilters: _propTypes["default"].object,
  hasMore: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  actions: _propTypes["default"].node,
  totalActivities: _propTypes["default"].number,
  isGlobalUltimate: _propTypes["default"].bool,
  dnbHierarchyCount: _propTypes["default"].number,
  isTypeFilterFlagEnabled: _propTypes["default"].bool,
  isGlobalUltimateFlagEnabled: _propTypes["default"].bool
});
(0, _defineProperty2["default"])(ActivityFeed, "defaultProps", {
  onLoadMore: function onLoadMore() {},
  sendQueryParams: function sendQueryParams() {},
  children: null,
  activities: [],
  activityTypeFilters: {},
  hasMore: false,
  isLoading: false,
  actions: null,
  totalActivities: 0,
  isGlobalUltimate: false,
  dnbHierarchyCount: null,
  isTypeFilterFlagEnabled: false,
  isGlobalUltimateFlagEnabled: false
});