"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _axios = _interopRequireDefault(require("axios"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ActivityFeed = _interopRequireDefault(require("./ActivityFeed"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * This component is not visible in Storybook - remember to also port your changes here,
 * as this one is going into production.
 */
var ActivityFeedApp = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ActivityFeedApp, _React$Component);

  var _super = _createSuper(ActivityFeedApp);

  function ActivityFeedApp(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, ActivityFeedApp);
    _this = _super.call(this, props);
    var activityTypeFilter = props.activityTypeFilter;
    _this.state = {
      activities: [],
      error: false,
      hasMore: true,
      isLoading: true,
      from: 0,
      total: 0,
      queryParams: {
        activityTypeFilter: activityTypeFilter,
        showDnbHierarchy: false
      }
    };
    _this.onLoadMore = _this.onLoadMore.bind((0, _assertThisInitialized2["default"])(_this));
    _this.setQueryParams = _this.setQueryParams.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(ActivityFeedApp, [{
    key: "componentDidMount",
    value: function () {
      var _componentDidMount = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.onLoadMore();

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function componentDidMount() {
        return _componentDidMount.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: "setQueryParams",
    value: function setQueryParams(queryParams) {
      this.setState({
        from: 0,
        activities: [],
        queryParams: queryParams
      }, this.onLoadMore);
    }
  }, {
    key: "onLoadMore",
    value: function () {
      var _onLoadMore = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var _this$state, activities, queryParams, from, apiEndpoint, size, _yield$ActivityFeedAp, newActivities, total, allActivities;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _this$state = this.state, activities = _this$state.activities, queryParams = _this$state.queryParams, from = _this$state.from;
                apiEndpoint = this.props.apiEndpoint;
                size = 20;
                this.setState({
                  isLoading: true
                });
                _context2.prev = 4;
                _context2.next = 7;
                return ActivityFeedApp.fetchActivities(apiEndpoint, from, size, queryParams);

              case 7:
                _yield$ActivityFeedAp = _context2.sent;
                newActivities = _yield$ActivityFeedAp.activities;
                total = _yield$ActivityFeedAp.total;
                allActivities = activities.concat(newActivities);
                this.setState({
                  activities: allActivities,
                  isLoading: false,
                  hasMore: total > allActivities.length,
                  from: from + size,
                  total: total
                });
                _context2.next = 17;
                break;

              case 14:
                _context2.prev = 14;
                _context2.t0 = _context2["catch"](4);
                this.setState({
                  isLoading: false,
                  hasMore: false,
                  error: true
                });

              case 17:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[4, 14]]);
      }));

      function onLoadMore() {
        return _onLoadMore.apply(this, arguments);
      }

      return onLoadMore;
    }()
  }, {
    key: "render",
    value: function render() {
      var _this$state2 = this.state,
          activities = _this$state2.activities,
          isLoading = _this$state2.isLoading,
          hasMore = _this$state2.hasMore,
          error = _this$state2.error,
          total = _this$state2.total;
      var _this$props = this.props,
          activityTypeFilters = _this$props.activityTypeFilters,
          actions = _this$props.actions,
          isGlobalUltimate = _this$props.isGlobalUltimate,
          dnbHierarchyCount = _this$props.dnbHierarchyCount,
          isTypeFilterFlagEnabled = _this$props.isTypeFilterFlagEnabled,
          isGlobalUltimateFlagEnabled = _this$props.isGlobalUltimateFlagEnabled;
      var isEmptyFeed = activities.length === 0 && !hasMore;
      return /*#__PURE__*/_react["default"].createElement(_ActivityFeed["default"], {
        activities: activities,
        activityTypeFilters: activityTypeFilters,
        actions: actions,
        isLoading: isLoading,
        hasMore: hasMore,
        onLoadMore: this.onLoadMore,
        sendQueryParams: this.setQueryParams,
        totalActivities: total,
        isGlobalUltimate: isGlobalUltimate,
        dnbHierarchyCount: dnbHierarchyCount,
        isTypeFilterFlagEnabled: isTypeFilterFlagEnabled,
        isGlobalUltimateFlagEnabled: isGlobalUltimateFlagEnabled
      }, isEmptyFeed && !error && /*#__PURE__*/_react["default"].createElement("div", null, "There are no activities to show."), error && /*#__PURE__*/_react["default"].createElement("div", null, "Error occurred while loading activities."));
    }
  }], [{
    key: "fetchActivities",
    value: function () {
      var _fetchActivities = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(apiEndpoint, from, size, queryParams) {
        var activityTypeFilter, showDnbHierarchy, params, _yield$axios$get, data, _data$hits, total, hits;

        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                activityTypeFilter = queryParams.activityTypeFilter, showDnbHierarchy = queryParams.showDnbHierarchy;
                params = {
                  from: from,
                  size: size,
                  activityTypeFilter: activityTypeFilter,
                  showDnbHierarchy: showDnbHierarchy
                };
                _context3.next = 4;
                return _axios["default"].get(apiEndpoint, {
                  params: params
                });

              case 4:
                _yield$axios$get = _context3.sent;
                data = _yield$axios$get.data;
                _data$hits = data.hits, total = _data$hits.total, hits = _data$hits.hits;
                return _context3.abrupt("return", {
                  total: total,
                  activities: hits.map(function (hit) {
                    return hit._source;
                  })
                });

              case 8:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function fetchActivities(_x, _x2, _x3, _x4) {
        return _fetchActivities.apply(this, arguments);
      }

      return fetchActivities;
    }()
  }]);
  return ActivityFeedApp;
}(_react["default"].Component);

exports["default"] = ActivityFeedApp;
(0, _defineProperty2["default"])(ActivityFeedApp, "propTypes", {
  actions: _propTypes["default"].node,
  activityTypeFilter: _propTypes["default"].string,
  activityTypeFilters: _propTypes["default"].object,
  apiEndpoint: _propTypes["default"].string.isRequired,
  isGlobalUltimate: _propTypes["default"].bool,
  dnbHierarchyCount: _propTypes["default"].number,
  isTypeFilterFlagEnabled: _propTypes["default"].bool,
  isGlobalUltimateFlagEnabled: _propTypes["default"].bool
});
(0, _defineProperty2["default"])(ActivityFeedApp, "defaultProps", {
  activityTypeFilter: null,
  activityTypeFilters: {},
  actions: null,
  isGlobalUltimate: false,
  dnbHierarchyCount: null,
  isTypeFilterFlagEnabled: false,
  isGlobalUltimateFlagEnabled: false
});