"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _constants = require("@govuk-react/constants");

var _govukColours = require("govuk-colours");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _checkbox = _interopRequireDefault(require("@govuk-react/checkbox"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  display: flex;\n  align-items: center;\n  min-height: 26px;\n  margin-bottom: 0;\n\n  & > span {\n    margin: 0;\n    padding: 0;\n    white-space: nowrap;\n\n    &::before {\n      background: ", ";\n      width: 26px;\n      height: 26px;\n    }\n\n    &::after {\n      top: 6px;\n      left: ", ";\n      width: 12px;\n      height: 6px;\n      box-sizing: unset;\n      border-width: 0 0 ", " ", ";\n    }\n  }\n\n  input {\n    width: 26px;\n    height: 26px;\n    margin: 0;\n    padding: 0;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledCheckbox = (0, _styledComponents["default"])(_checkbox["default"])(_templateObject(), _govukColours.WHITE, _constants.SPACING.SCALE_1, _constants.BORDER_WIDTH_MOBILE, _constants.BORDER_WIDTH_MOBILE);

var ActivityFeedCheckbox = function ActivityFeedCheckbox(props) {
  var children = props.children,
      rest = (0, _objectWithoutProperties2["default"])(props, ["children"]);
  return /*#__PURE__*/_react["default"].createElement(StyledCheckbox, rest, children);
};

ActivityFeedCheckbox.propTypes = {
  children: _propTypes["default"].node.isRequired,
  onChange: _propTypes["default"].func.isRequired,
  checked: _propTypes["default"].bool,
  name: _propTypes["default"].string
};
ActivityFeedCheckbox.defaultProps = {
  checked: null,
  name: null
};
var _default = ActivityFeedCheckbox;
exports["default"] = _default;