"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _govukColours = require("govuk-colours");

var _constants = require("@govuk-react/constants");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _SelectFilter = _interopRequireDefault(require("./filters/SelectFilter"));

var _ActivityFeedCheckbox = _interopRequireDefault(require("./ActivityFeedCheckbox"));

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin-right: ", ";\n  white-space: nowrap;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  background: ", ";\n  align-items: center;\n  padding: 11px;\n\n  ", " {\n    margin-right: ", ";\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  padding: ", ";\n  background: ", ";\n  display: block;\n  align-items: center;\n\n  ", " {\n    display: flex;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var ActivityFeedFiltersRow = (0, _styledComponents["default"])('div')(_templateObject(), _constants.SPACING.SCALE_2, _govukColours.GREY_3, _constants.MEDIA_QUERIES.DESKTOP);
var StyledCheckboxContainer = (0, _styledComponents["default"])('div')(_templateObject2(), _govukColours.GREY_4, _constants.MEDIA_QUERIES.DESKTOP, _constants.SPACING.SCALE_5);
var StyledTitle = (0, _styledComponents["default"])('h4')(_templateObject3(), _constants.SPACING.SCALE_4);

var ActivityFeedFilters = function ActivityFeedFilters(_ref) {
  var activityTypeFilters = _ref.activityTypeFilters,
      activityTypeFilter = _ref.activityTypeFilter,
      onActivityTypeFilterChange = _ref.onActivityTypeFilterChange,
      showActivitiesFromAllCompanies = _ref.showActivitiesFromAllCompanies,
      isGlobalUltimate = _ref.isGlobalUltimate,
      dnbHierarchyCount = _ref.dnbHierarchyCount,
      isGlobalUltimateFlagEnabled = _ref.isGlobalUltimateFlagEnabled,
      isTypeFilterFlagEnabled = _ref.isTypeFilterFlagEnabled;
  var isGlobalAndEnabled = isGlobalUltimate && isGlobalUltimateFlagEnabled;
  var showDnbHierarchyFilter = isGlobalAndEnabled && dnbHierarchyCount > 1;
  return /*#__PURE__*/_react["default"].createElement(ActivityFeedFiltersRow, null, /*#__PURE__*/_react["default"].createElement(StyledTitle, null, "Filter by"), showDnbHierarchyFilter && /*#__PURE__*/_react["default"].createElement(StyledCheckboxContainer, null, /*#__PURE__*/_react["default"].createElement(_ActivityFeedCheckbox["default"], {
    name: "ultimateHQSubsidiariesFilter",
    onChange: showActivitiesFromAllCompanies
  }, "Activity across all ", dnbHierarchyCount, " companies")), isTypeFilterFlagEnabled && /*#__PURE__*/_react["default"].createElement(_SelectFilter["default"], {
    filters: activityTypeFilters,
    onActivityTypeFilterChange: onActivityTypeFilterChange,
    value: activityTypeFilter
  }));
};

ActivityFeedFilters.propTypes = {
  activityTypeFilters: _propTypes["default"].array.isRequired,
  activityTypeFilter: _propTypes["default"].string.isRequired,
  onActivityTypeFilterChange: _propTypes["default"].func.isRequired,
  showActivitiesFromAllCompanies: _propTypes["default"].func.isRequired,
  dnbHierarchyCount: _propTypes["default"].number,
  isGlobalUltimate: _propTypes["default"].bool.isRequired,
  isGlobalUltimateFlagEnabled: _propTypes["default"].bool.isRequired,
  isTypeFilterFlagEnabled: _propTypes["default"].bool.isRequired
};
ActivityFeedFilters.defaultProps = {
  dnbHierarchyCount: null
};
var _default = ActivityFeedFilters;
exports["default"] = _default;