"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _heading = require("@govuk-react/heading");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _constants = require("@govuk-react/constants");

var _pluralize = _interopRequireDefault(require("pluralize"));

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  text-align: right;\n  min-width: 60%;\n\n  & > button {\n    margin-bottom: 0;\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin-top: ", ";\n\n  & > h2 {\n    font-weight: normal;\n    font-size: 28px;\n    margin-bottom: 0;\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  display: flex;\n  flex-flow: row wrap;\n  border-bottom: 2px solid #000;\n  margin-bottom: ", ";\n  padding-bottom: ", ";\n\n  & > div {\n    width: 100%;\n    margin-bottom: ", ";\n\n    ", " {\n      width: 0;\n      flex-grow: 1;\n    }\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var HeaderSummary = (0, _styledComponents["default"])('div')(_templateObject(), _constants.SPACING.SCALE_2, _constants.SPACING.SCALE_1, _constants.SPACING.SCALE_1, _constants.MEDIA_QUERIES.TABLET);
var HeaderCount = (0, _styledComponents["default"])('div')(_templateObject2(), _constants.SPACING.SCALE_1);
var HeaderActions = (0, _styledComponents["default"])('div')(_templateObject3());

var ActivityFeedHeader = function ActivityFeedHeader(_ref) {
  var totalActivities = _ref.totalActivities,
      actions = _ref.actions;
  var headerText = totalActivities ? (0, _pluralize["default"])('activity', totalActivities, true) : 'Activities';
  return /*#__PURE__*/_react["default"].createElement(HeaderSummary, null, /*#__PURE__*/_react["default"].createElement(HeaderCount, null, /*#__PURE__*/_react["default"].createElement(_heading.H2, null, headerText)), actions && /*#__PURE__*/_react["default"].createElement(HeaderActions, null, actions));
};

ActivityFeedHeader.propTypes = {
  totalActivities: _propTypes["default"].number,
  actions: _propTypes["default"].node
};
ActivityFeedHeader.defaultProps = {
  totalActivities: 0,
  actions: null
};
var _default = ActivityFeedHeader;
exports["default"] = _default;