"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _lodash = require("lodash");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _card = require("./card");

var _CardUtils = _interopRequireDefault(require("./card/CardUtils"));

var _DateUtils = _interopRequireDefault(require("../../utils/DateUtils"));

var _NumberUtils = _interopRequireDefault(require("../../utils/NumberUtils"));

var _constants = require("../constants");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var CompaniesHouseAccount = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2["default"])(CompaniesHouseAccount, _React$PureComponent);

  var _super = _createSuper(CompaniesHouseAccount);

  function CompaniesHouseAccount() {
    (0, _classCallCheck2["default"])(this, CompaniesHouseAccount);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(CompaniesHouseAccount, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          activity = _this$props.activity,
          showDetails = _this$props.showDetails,
          showDnbHierarchy = _this$props.showDnbHierarchy;
      var startTime = (0, _lodash.get)(activity, 'object.startTime');
      var taxonomy = (0, _lodash.get)(activity, 'dit:taxonomy');
      var summary = (0, _lodash.get)(activity, 'summary');

      var company = _CardUtils["default"].getCompany(activity);

      var balanceSheetDate = _DateUtils["default"].format((0, _lodash.get)(activity, 'object.dit:balanceSheetDate'));

      var netAssetsLiabilities = _NumberUtils["default"].currencyGBP((0, _lodash.get)(activity, 'object.dit:netAssetsLiabilitiesIncludingPensionAssetLiability'));

      var periodEnd = _DateUtils["default"].format((0, _lodash.get)(activity, 'object.dit:periodEnd'));

      var periodStart = _DateUtils["default"].format((0, _lodash.get)(activity, 'object.dit:periodStart'));

      var shareholderFunds = _NumberUtils["default"].currencyGBP((0, _lodash.get)(activity, 'object.dit:shareholderFunds'));

      return /*#__PURE__*/_react["default"].createElement(_card.Card, null, /*#__PURE__*/_react["default"].createElement(_card.CardHeader, {
        company: showDnbHierarchy ? company : null,
        heading: summary,
        blockText: "Companies House",
        sourceType: _constants.SOURCE_TYPES.external,
        subHeading: "Accounts records",
        startTime: startTime
      }), /*#__PURE__*/_react["default"].createElement(_card.CardDetails, {
        summary: "View key details for this account",
        link: {
          taxonomy: taxonomy,
          text: 'Go to the Companies House accounts page'
        },
        showDetails: showDetails
      }, /*#__PURE__*/_react["default"].createElement(_card.CardTable, {
        rows: [{
          header: 'Balance sheet date',
          content: balanceSheetDate
        }, {
          header: 'Net assets liabilities including pension asset liability',
          content: netAssetsLiabilities
        }, {
          header: 'Period start',
          content: periodStart
        }, {
          header: 'Period end',
          content: periodEnd
        }, {
          header: 'Shareholder funds',
          content: shareholderFunds
        }]
      })));
    }
  }], [{
    key: "canRender",
    value: function canRender(activity) {
      return _CardUtils["default"].canRenderByTypes(activity, _constants.ACTIVITY_TYPE.CompaniesHouseAccount);
    }
  }]);
  return CompaniesHouseAccount;
}(_react["default"].PureComponent);

exports["default"] = CompaniesHouseAccount;
(0, _defineProperty2["default"])(CompaniesHouseAccount, "propTypes", {
  activity: _propTypes["default"].object.isRequired,
  showDetails: _propTypes["default"].bool.isRequired,
  showDnbHierarchy: _propTypes["default"].bool.isRequired
});