"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _lodash = require("lodash");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _card = require("./card");

var _itemRenderers = require("./card/item-renderers");

var _CardUtils = _interopRequireDefault(require("./card/CardUtils"));

var _DateUtils = _interopRequireDefault(require("../../utils/DateUtils"));

var _constants = require("../constants");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var CompaniesHouseCompany = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2["default"])(CompaniesHouseCompany, _React$PureComponent);

  var _super = _createSuper(CompaniesHouseCompany);

  function CompaniesHouseCompany() {
    (0, _classCallCheck2["default"])(this, CompaniesHouseCompany);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(CompaniesHouseCompany, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          activity = _this$props.activity,
          showDetails = _this$props.showDetails,
          showDnbHierarchy = _this$props.showDnbHierarchy;

      var company = _CardUtils["default"].getCompany(activity);

      var startTime = (0, _lodash.get)(activity, 'object.startTime');
      var reference = (0, _lodash.get)(activity, 'object.name');
      var summary = (0, _lodash.get)(activity, 'summary');
      var address = (0, _lodash.get)(activity, 'object.location:dit:address');
      var postcode = (0, _lodash.get)(activity, 'object.location:dit:postcode');

      var confStmtLastMadeUpDate = _DateUtils["default"].format((0, _lodash.get)(activity, 'object.dit:confStmtLastMadeUpDate'));

      var confStmtNextDueDate = _DateUtils["default"].format((0, _lodash.get)(activity, 'object.dit:confStmtNextDueDate'));

      var incorporationDate = _DateUtils["default"].format((0, _lodash.get)(activity, 'object.dit:incorporationDate'));

      var nextDueDate = _DateUtils["default"].format((0, _lodash.get)(activity, 'object.dit:nextDueDate'));

      var returnsLastMadeUpDate = _DateUtils["default"].format((0, _lodash.get)(activity, 'object.dit:returnsLastMadeUpDate'));

      var returnsNextDueDate = _DateUtils["default"].format((0, _lodash.get)(activity, 'object.dit:returnsNextDueDate'));

      var sicCodes = (0, _lodash.get)(activity, 'object.dit:sicCodes');
      var sicCodesCollection = sicCodes.map(function (value) {
        return {
          value: value,
          id: value
        };
      });
      return /*#__PURE__*/_react["default"].createElement(_card.Card, null, /*#__PURE__*/_react["default"].createElement(_card.CardHeader, {
        company: showDnbHierarchy ? company : null,
        heading: summary,
        blockText: "Companies House",
        sourceType: _constants.SOURCE_TYPES.external,
        subHeading: "Company records",
        startTime: startTime
      }), /*#__PURE__*/_react["default"].createElement(_card.CardDetails, {
        summary: "View key details for this company",
        showDetails: showDetails
      }, /*#__PURE__*/_react["default"].createElement(_card.CardTable, {
        rows: [{
          header: 'Company name',
          content: reference
        }, {
          header: 'Address',
          content: address
        }, {
          header: 'Postcode',
          content: postcode
        }, {
          header: 'Confirmation Statement last made up date',
          content: confStmtLastMadeUpDate
        }, {
          header: 'Confirmation Statement next due date',
          content: confStmtNextDueDate
        }, {
          header: 'Incorporation date',
          content: incorporationDate
        }, {
          header: 'Next due date',
          content: nextDueDate
        }, {
          header: 'Returns last made up date',
          content: returnsLastMadeUpDate
        }, {
          header: 'Returns next due date',
          content: returnsNextDueDate
        }, {
          header: 'SIC code(s)',
          content: /*#__PURE__*/_react["default"].createElement(_card.CardDetailsList, {
            itemPropName: "value",
            itemRenderer: _itemRenderers.DefaultItemRenderer,
            items: sicCodesCollection
          })
        }]
      })));
    }
  }], [{
    key: "canRender",
    value: function canRender(activity) {
      return _CardUtils["default"].canRenderByTypes(activity, _constants.ACTIVITY_TYPE.CompaniesHouseCompany);
    }
  }]);
  return CompaniesHouseCompany;
}(_react["default"].PureComponent);

exports["default"] = CompaniesHouseCompany;
(0, _defineProperty2["default"])(CompaniesHouseCompany, "propTypes", {
  activity: _propTypes["default"].object.isRequired,
  showDetails: _propTypes["default"].bool.isRequired,
  showDnbHierarchy: _propTypes["default"].bool.isRequired
});