"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _lodash = require("lodash");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _card = require("./card");

var _itemRenderers = require("./card/item-renderers");

var _CardUtils = _interopRequireDefault(require("./card/CardUtils"));

var _constants = require("../constants");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var HmrcExporter = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2["default"])(HmrcExporter, _React$PureComponent);

  var _super = _createSuper(HmrcExporter);

  function HmrcExporter() {
    (0, _classCallCheck2["default"])(this, HmrcExporter);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(HmrcExporter, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          activity = _this$props.activity,
          showDetails = _this$props.showDetails,
          showDnbHierarchy = _this$props.showDnbHierarchy;

      var company = _CardUtils["default"].getCompany(activity);

      var startTime = (0, _lodash.get)(activity, 'object.startTime');
      var reference = (0, _lodash.get)(activity, 'object.attributedTo.name');
      var summary = (0, _lodash.get)(activity, 'summary');
      var exportItemCodes = (0, _lodash.get)(activity, 'object.dit:exportItemCodes');
      var exportItemCodesCollection = exportItemCodes.map(function (value) {
        return {
          value: value,
          id: value
        };
      });
      return /*#__PURE__*/_react["default"].createElement(_card.Card, null, /*#__PURE__*/_react["default"].createElement(_card.CardHeader, {
        company: showDnbHierarchy ? company : null,
        blockText: "HMRC",
        subHeading: "Exporters records",
        heading: summary,
        sourceType: _constants.SOURCE_TYPES.external,
        startTime: startTime
      }), /*#__PURE__*/_react["default"].createElement(_card.CardDetails, {
        summary: "View key export details",
        showDetails: showDetails
      }, /*#__PURE__*/_react["default"].createElement(_card.CardTable, {
        rows: [{
          header: 'Company name',
          content: reference
        }, {
          header: 'Export Item code(s)',
          content: /*#__PURE__*/_react["default"].createElement(_card.CardDetailsList, {
            itemPropName: "value",
            itemRenderer: _itemRenderers.DefaultItemRenderer,
            items: exportItemCodesCollection
          })
        }]
      })));
    }
  }], [{
    key: "canRender",
    value: function canRender(activity) {
      return _CardUtils["default"].canRenderByTypes(activity, _constants.ACTIVITY_TYPE.HmrcExporter);
    }
  }]);
  return HmrcExporter;
}(_react["default"].PureComponent);

exports["default"] = HmrcExporter;
(0, _defineProperty2["default"])(HmrcExporter, "propTypes", {
  activity: _propTypes["default"].object.isRequired,
  showDetails: _propTypes["default"].bool.isRequired,
  showDnbHierarchy: _propTypes["default"].bool.isRequired
});