"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _link = _interopRequireDefault(require("@govuk-react/link"));

var _card = require("./card");

var _itemRenderers = require("./card/item-renderers");

var _constants = require("../constants");

var _CardUtils = _interopRequireDefault(require("./card/CardUtils"));

var _InteractionUtils = _interopRequireDefault(require("./InteractionUtils"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var Interaction = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2["default"])(Interaction, _React$PureComponent);

  var _super = _createSuper(Interaction);

  function Interaction() {
    (0, _classCallCheck2["default"])(this, Interaction);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(Interaction, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          activity = _this$props.activity,
          showDetails = _this$props.showDetails,
          showDnbHierarchy = _this$props.showDnbHierarchy;

      var transformed = _objectSpread(_objectSpread({}, _CardUtils["default"].transform(activity)), _InteractionUtils["default"].transform(activity));

      var company = showDnbHierarchy && _CardUtils["default"].getCompany(activity);

      var contacts = _CardUtils["default"].getContacts(activity);

      var advisers = _CardUtils["default"].getAdvisers(activity);

      return /*#__PURE__*/_react["default"].createElement(_card.Card, {
        isUpcoming: transformed.isUpcoming
      }, /*#__PURE__*/_react["default"].createElement(_card.CardHeader, {
        company: showDnbHierarchy ? company : null,
        heading: /*#__PURE__*/_react["default"].createElement(_link["default"], {
          href: transformed.url
        }, transformed.subject),
        startTime: transformed.startTime,
        badge: transformed.badge
      }), /*#__PURE__*/_react["default"].createElement(_card.CardDetails, {
        summary: "View ".concat(transformed.typeText, " details"),
        link: {
          url: transformed.url,
          text: "Go to the ".concat(transformed.typeText, " detail page")
        },
        showDetails: showDetails
      }, /*#__PURE__*/_react["default"].createElement(_card.CardTable, {
        rows: [{
          header: 'Company contact(s)',
          content: /*#__PURE__*/_react["default"].createElement(_card.CardDetailsList, {
            itemRenderer: _itemRenderers.ContactItemRenderer,
            items: contacts
          })
        }, {
          header: 'Adviser(s)',
          content: /*#__PURE__*/_react["default"].createElement(_card.CardDetailsList, {
            itemRenderer: _itemRenderers.AdviserItemRenderer,
            items: advisers
          })
        }, {
          header: 'Services',
          content: transformed.service
        }]
      })));
    }
  }], [{
    key: "canRender",
    value: function canRender(activity) {
      return _CardUtils["default"].canRenderByTypes(activity, _constants.ACTIVITY_TYPE.Interaction);
    }
  }]);
  return Interaction;
}(_react["default"].PureComponent);

exports["default"] = Interaction;
(0, _defineProperty2["default"])(Interaction, "propTypes", {
  activity: _propTypes["default"].object.isRequired,
  showDetails: _propTypes["default"].bool.isRequired,
  showDnbHierarchy: _propTypes["default"].bool.isRequired
});