"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _lodash = require("lodash");

var _constants = require("../constants");

var getStatus = function getStatus(activity) {
  var apiStatus = (0, _lodash.get)(activity, 'object.dit:status');

  if (apiStatus === _constants.STATUS.DRAFT) {
    var isArchived = (0, _lodash.get)(activity, 'object.dit:archived');

    if (isArchived) {
      return _constants.STATUS.CANCELLED;
    }

    var startTime = (0, _lodash.get)(activity, 'object.startTime');
    var isUpcoming = new Date(startTime) > new Date();
    return isUpcoming ? _constants.STATUS.UPCOMING : _constants.STATUS.INCOMPLETE;
  }

  return _constants.STATUS.COMPLETE;
};

var isServiceDelivery = function isServiceDelivery(activity) {
  var activityTypes = (0, _lodash.get)(activity, 'object.type');
  return (0, _lodash.includes)(activityTypes, 'dit:ServiceDelivery');
};

var InteractionUtils = /*#__PURE__*/function () {
  function InteractionUtils() {
    (0, _classCallCheck2["default"])(this, InteractionUtils);
  }

  (0, _createClass2["default"])(InteractionUtils, null, [{
    key: "transform",
    value: function transform(activity) {
      var status = getStatus(activity);
      var badge = isServiceDelivery(activity) ? _constants.BADGES.INTERACTION.SERVICE_DELIVERY : _constants.BADGES.INTERACTION[status.toUpperCase()];
      var isUpcoming = status === _constants.STATUS.UPCOMING;
      var typeText = isServiceDelivery(activity) ? 'service delivery' : 'interaction';
      return {
        badge: badge,
        isUpcoming: isUpcoming,
        typeText: typeText
      };
    }
  }]);
  return InteractionUtils;
}();

exports["default"] = InteractionUtils;