"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _link = _interopRequireDefault(require("@govuk-react/link"));

var _DateUtils = _interopRequireDefault(require("../../utils/DateUtils"));

var _card = require("./card");

var _constants = require("../constants");

var _CardUtils = _interopRequireDefault(require("./card/CardUtils"));

var _ReferralUtils = _interopRequireDefault(require("./ReferralUtils"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var Referral = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2["default"])(Referral, _React$PureComponent);

  var _super = _createSuper(Referral);

  function Referral() {
    (0, _classCallCheck2["default"])(this, Referral);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(Referral, [{
    key: "render",
    value: function render() {
      var activity = this.props.activity;

      var _ReferralUtils$transf = _ReferralUtils["default"].transformReferral(activity),
          id = _ReferralUtils$transf.id,
          companyId = _ReferralUtils$transf.companyId,
          subject = _ReferralUtils$transf.subject,
          startTime = _ReferralUtils$transf.startTime,
          sender = _ReferralUtils$transf.sender,
          recipient = _ReferralUtils$transf.recipient,
          completedOn = _ReferralUtils$transf.completedOn;

      var url = "/companies/".concat(companyId, "/referrals/").concat(id.split(':')[2]);

      var badge = _ReferralUtils["default"].getStatus(activity);

      var AdviserDetails = function AdviserDetails(_ref) {
        var name = _ref.name,
            email = _ref.email,
            team = _ref.team;
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, name, email && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, ", ", /*#__PURE__*/_react["default"].createElement("a", {
          href: "mailto:".concat(email)
        }, email)), team && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, ", ", team));
      };

      return /*#__PURE__*/_react["default"].createElement(_card.Card, null, /*#__PURE__*/_react["default"].createElement(_card.CardHeader, {
        heading: /*#__PURE__*/_react["default"].createElement(_link["default"], {
          href: url
        }, subject),
        startTime: startTime,
        badge: badge
      }), /*#__PURE__*/_react["default"].createElement(_card.CardTable, {
        isNotWrappedInDetails: true,
        rows: [{
          header: 'Sending adviser',
          content: AdviserDetails(sender)
        }, {
          header: 'Receiving adviser',
          content: AdviserDetails(recipient)
        }, {
          header: 'Completed on',
          content: completedOn && _DateUtils["default"].format(completedOn)
        }]
      }));
    }
  }], [{
    key: "canRender",
    value: function canRender(activity) {
      return _CardUtils["default"].canRenderByTypes(activity, _constants.ACTIVITY_TYPE.Referral);
    }
  }]);
  return Referral;
}(_react["default"].PureComponent);

exports["default"] = Referral;
(0, _defineProperty2["default"])(Referral, "propTypes", {
  activity: _propTypes["default"].object.isRequired
});