"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _lodash = require("lodash");

var _constants = require("../constants");

var ReferralUtils = /*#__PURE__*/function () {
  function ReferralUtils() {
    (0, _classCallCheck2["default"])(this, ReferralUtils);
  }

  (0, _createClass2["default"])(ReferralUtils, null, [{
    key: "getStatus",
    value: function getStatus(activity) {
      var status = (0, _lodash.get)(activity, 'object.dit:status');
      return _constants.BADGES.REFERRAL[status.toUpperCase()];
    }
  }, {
    key: "getRoleDetails",
    value: function getRoleDetails(activity, role) {
      return activity.object.attributedTo.filter(function (attr) {
        return attr['dit:DataHubCompanyReferral:role'] === role;
      });
    }
  }, {
    key: "transformReferral",
    value: function transformReferral(activity) {
      var _this$getRoleDetails = this.getRoleDetails(activity, 'sender'),
          _this$getRoleDetails2 = (0, _slicedToArray2["default"])(_this$getRoleDetails, 1),
          sender = _this$getRoleDetails2[0];

      var _this$getRoleDetails3 = this.getRoleDetails(activity, 'recipient'),
          _this$getRoleDetails4 = (0, _slicedToArray2["default"])(_this$getRoleDetails3, 1),
          recipient = _this$getRoleDetails4[0];

      return {
        id: (0, _lodash.get)(activity, 'id'),
        companyId: activity.object.attributedTo[0].id.split(':').pop(),
        startTime: (0, _lodash.get)(activity, 'object.startTime'),
        subject: (0, _lodash.get)(activity, 'object.dit:subject'),
        status: (0, _lodash.get)(activity, 'object.dit:status'),
        sender: {
          name: (0, _lodash.get)(sender, 'name'),
          email: (0, _lodash.get)(sender, 'dit:emailAddress'),
          team: (0, _lodash.get)(sender, 'dit:team[name]')
        },
        recipient: {
          name: (0, _lodash.get)(recipient, 'name'),
          email: (0, _lodash.get)(recipient, 'dit:emailAddress'),
          team: (0, _lodash.get)(recipient, 'dit:team[name]')
        },
        completedOn: (0, _lodash.get)(activity, 'object.dit:completedOn')
      };
    }
  }]);
  return ReferralUtils;
}();

exports["default"] = ReferralUtils;