"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _govukColours = require("govuk-colours");

var _heading = require("@govuk-react/heading");

var _listItem = _interopRequireDefault(require("@govuk-react/list-item"));

var _constants = require("@govuk-react/constants");

var _Badge = _interopRequireDefault(require("../../../badge/Badge"));

var _constants2 = require("../../constants");

var _DateUtils = _interopRequireDefault(require("../../../utils/DateUtils"));

function _templateObject7() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  list-style: none;\n  padding: 0;\n  margin: 0;\n\n  li {\n    font-size: ", ";\n    margin-bottom: ", ";\n    text-align: right;\n    display: inline;\n\n    ", " {\n      display: block;\n    }\n  }\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-weight: normal;\n  font-size: ", "px;\n  margin-left: ", "px;\n  color: ", ";\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-weight: normal;\n  font-size: ", "px;\n\n  & > a:link,\n  a:visited,\n  a:hover,\n  a:active {\n    text-decoration: none;\n    color: ", ";\n  }\n\n  ", " {\n    margin-bottom: ", ";\n  }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  width: 100%;\n\n  ", " {\n    width: 0;\n    flex-grow: 1;\n  }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin: -", " -", " ", " -", ";\n  padding: ", " ", ";\n  background: ", ";\n  font-size: initial;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  display: flex;\n  flex-flow: row wrap;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  display: inline-block;\n  font-weight: normal;\n  color: white;\n  padding: 2px 5px;\n  background-color: ", ";\n  margin-bottom: ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledBlockText = (0, _styledComponents["default"])(_heading.H3)(_templateObject(), function (_ref) {
  var sourceType = _ref.sourceType;
  return sourceType === _constants2.SOURCE_TYPES.external ? _govukColours.GREY_1 : _govukColours.BLUE;
}, _constants.SPACING.SCALE_2);
var StyledCardHeader = (0, _styledComponents["default"])('div')(_templateObject2());
var StyledCompanyName = (0, _styledComponents["default"])('div')(_templateObject3(), _constants.SPACING.SCALE_3, _constants.SPACING.SCALE_3, _constants.SPACING.SCALE_4, _constants.SPACING.SCALE_3, _constants.SPACING.SCALE_2, _constants.SPACING.SCALE_3, _govukColours.GREY_4);
var StyledHeadingWrapper = (0, _styledComponents["default"])('div')(_templateObject4(), _constants.MEDIA_QUERIES.TABLET);
var StyledHeading = (0, _styledComponents["default"])(_heading.H3)(_templateObject5(), _constants.HEADING_SIZES.MEDIUM, _govukColours.BLUE, _constants.MEDIA_QUERIES.TABLET, _constants.SPACING.SCALE_5);
var StyledSubHeading = (0, _styledComponents["default"])('span')(_templateObject6(), _constants.BODY_SIZES.MEDIUM, _constants.SPACING_POINTS['1'], _govukColours.GREY_1);
var StyledMetaItems = (0, _styledComponents["default"])('ul')(_templateObject7(), _constants.FONT_SIZE.SIZE_16, _constants.SPACING.SCALE_2, _constants.MEDIA_QUERIES.TABLET);

var CardHeader = function CardHeader(_ref2) {
  var blockText = _ref2.blockText,
      subHeading = _ref2.subHeading,
      company = _ref2.company,
      sourceType = _ref2.sourceType,
      heading = _ref2.heading,
      startTime = _ref2.startTime,
      badge = _ref2.badge;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, company && company.name && /*#__PURE__*/_react["default"].createElement(StyledCompanyName, null, company.name), /*#__PURE__*/_react["default"].createElement(StyledCardHeader, null, /*#__PURE__*/_react["default"].createElement(StyledHeadingWrapper, null, blockText && /*#__PURE__*/_react["default"].createElement(StyledBlockText, {
    sourceType: sourceType
  }, blockText), subHeading && /*#__PURE__*/_react["default"].createElement(StyledSubHeading, null, subHeading), heading && /*#__PURE__*/_react["default"].createElement(StyledHeading, null, heading)), /*#__PURE__*/_react["default"].createElement(StyledMetaItems, null, startTime && /*#__PURE__*/_react["default"].createElement(_listItem["default"], null, _DateUtils["default"].format(startTime)), badge && /*#__PURE__*/_react["default"].createElement(_listItem["default"], null, /*#__PURE__*/_react["default"].createElement(_Badge["default"], {
    borderColour: badge.borderColour
  }, badge.text)))));
};

CardHeader.propTypes = {
  startTime: _propTypes["default"].string,
  heading: _propTypes["default"].node,
  blockText: _propTypes["default"].string,
  subHeading: _propTypes["default"].string,
  company: _propTypes["default"].shape({
    name: _propTypes["default"].string
  }),
  sourceType: _propTypes["default"].oneOf(Object.values(_constants2.SOURCE_TYPES)),
  badge: _propTypes["default"].shape({
    text: _propTypes["default"].string,
    borderColour: _propTypes["default"].string
  })
};
CardHeader.defaultProps = {
  startTime: null,
  heading: null,
  blockText: null,
  subHeading: null,
  company: null,
  badge: null,
  sourceType: null
};
var _default = CardHeader;
exports["default"] = _default;