"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _table = _interopRequireDefault(require("@govuk-react/table"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _constants = require("@govuk-react/constants");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  ", " {\n    margin-bottom: ", ";\n  }\n\n  th {\n    width: ", ";\n  }\n\n  th,\n  td {\n    font-weight: normal;\n    border: 0;\n    padding: ", ";\n    font-size: 16px;\n    vertical-align: top;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var GovUkTable = (0, _styledComponents["default"])(_table["default"])(_templateObject(), _constants.MEDIA_QUERIES.TABLET, function (_ref) {
  var isNotWrappedInDetails = _ref.isNotWrappedInDetails;
  return isNotWrappedInDetails ? '0' : _constants.SPACING.SCALE_2;
}, function (_ref2) {
  var isNotWrappedInDetails = _ref2.isNotWrappedInDetails;
  return isNotWrappedInDetails ? '284px' : '270px';
}, _constants.SPACING.SCALE_2);

var DetailsRow = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2["default"])(DetailsRow, _React$PureComponent);

  var _super = _createSuper(DetailsRow);

  function DetailsRow() {
    (0, _classCallCheck2["default"])(this, DetailsRow);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(DetailsRow, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          header = _this$props.header,
          children = _this$props.children;

      if (!children) {
        return null;
      }

      return /*#__PURE__*/_react["default"].createElement(_table["default"].Row, null, /*#__PURE__*/_react["default"].createElement(_table["default"].CellHeader, {
        style: {
          fontWeight: 'normal',
          border: 0
        }
      }, header), /*#__PURE__*/_react["default"].createElement(_table["default"].Cell, {
        style: {
          border: 0
        }
      }, children));
    }
  }]);
  return DetailsRow;
}(_react["default"].PureComponent);

(0, _defineProperty2["default"])(DetailsRow, "propTypes", {
  header: _propTypes["default"].string.isRequired,
  children: _propTypes["default"].node
});
(0, _defineProperty2["default"])(DetailsRow, "defaultProps", {
  children: null
});

var CardTable = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(CardTable, _React$Component);

  var _super2 = _createSuper(CardTable);

  function CardTable() {
    (0, _classCallCheck2["default"])(this, CardTable);
    return _super2.apply(this, arguments);
  }

  (0, _createClass2["default"])(CardTable, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          rows = _this$props2.rows,
          isNotWrappedInDetails = _this$props2.isNotWrappedInDetails;
      return /*#__PURE__*/_react["default"].createElement(GovUkTable, {
        isNotWrappedInDetails: isNotWrappedInDetails
      }, rows.map(function (_ref3) {
        var header = _ref3.header,
            content = _ref3.content;
        return /*#__PURE__*/_react["default"].createElement(DetailsRow, {
          header: header,
          key: header
        }, content);
      }));
    }
  }]);
  return CardTable;
}(_react["default"].Component);

exports["default"] = CardTable;
(0, _defineProperty2["default"])(CardTable, "propTypes", {
  isNotWrappedInDetails: _propTypes["default"].bool,
  rows: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    header: _propTypes["default"].string,
    content: _propTypes["default"].node
  })).isRequired
});
(0, _defineProperty2["default"])(CardTable, "defaultProps", {
  isNotWrappedInDetails: false
});