"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ACTIVITY_TYPE_FILTERS = exports.ACTIVITY_TYPE = exports.SOURCE_TYPES = exports.BADGES = exports.STATUS = void 0;

var _govukColours = require("govuk-colours");

var STATUS = {
  DRAFT: 'draft',
  COMPLETE: 'complete',
  UPCOMING: 'upcoming',
  INCOMPLETE: 'incomplete',
  CANCELLED: 'cancelled'
};
exports.STATUS = STATUS;
var BADGES = {
  INTERACTION: {
    COMPLETE: {
      text: 'Interaction',
      borderColour: _govukColours.GREEN
    },
    UPCOMING: {
      text: 'Upcoming interaction',
      borderColour: _govukColours.BLUE
    },
    INCOMPLETE: {
      text: 'Incomplete interaction',
      borderColour: _govukColours.BLUE
    },
    CANCELLED: {
      text: 'Cancelled interaction',
      borderColour: _govukColours.RED
    },
    SERVICE_DELIVERY: {
      text: 'Service delivery',
      borderColour: _govukColours.GREEN
    }
  },
  REFERRAL: {
    COMPLETE: {
      text: 'Completed referral',
      borderColour: _govukColours.GREEN
    },
    OUTSTANDING: {
      text: 'Outstanding referral',
      borderColour: _govukColours.BLUE
    }
  }
};
exports.BADGES = BADGES;
var SOURCE_TYPES = {
  external: 'externalDataSource'
};
exports.SOURCE_TYPES = SOURCE_TYPES;
var ACTIVITY_TYPE = {
  CompaniesHouseAccount: ['dit:Accounts'],
  CompaniesHouseCompany: ['dit:Company'],
  HmrcExporter: ['dit:Export'],
  Interaction: ['dit:Interaction', 'dit:ServiceDelivery'],
  InvestmentProject: ['dit:InvestmentProject'],
  Omis: ['dit:OMISOrder'],
  Referral: ['dit:CompanyReferral']
};
exports.ACTIVITY_TYPE = ACTIVITY_TYPE;
var ACTIVITY_TYPE_FILTERS = {
  allActivity: {
    label: 'All Data Hub & external activity',
    value: 'allActivity'
  },
  myActivity: {
    label: 'My activity',
    value: 'myActivity'
  },
  externalActivity: {
    label: 'All external activity',
    value: 'externalActivity'
  },
  dataHubActivity: {
    label: 'All Data Hub activity',
    value: 'dataHubActivity'
  }
};
exports.ACTIVITY_TYPE_FILTERS = ACTIVITY_TYPE_FILTERS;
var _default = {
  ACTIVITY_TYPE: ACTIVITY_TYPE,
  ACTIVITY_TYPE_FILTERS: ACTIVITY_TYPE_FILTERS,
  SOURCE_TYPES: SOURCE_TYPES,
  STATUS: STATUS,
  BADGES: BADGES
};
exports["default"] = _default;