"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _lodash = require("lodash");

var _select = _interopRequireDefault(require("@govuk-react/select"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _constants = require("@govuk-react/constants");

var _govukColours = require("govuk-colours");

var _propTypes = _interopRequireDefault(require("prop-types"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  background: ", ";\n  padding: ", "\n  display: block;\n  \n  ", " {\n    display: inline-flex;\n  }\n  \n  label {\n    display: block;\n    \n    ", " {\n      display: inline-block;\n    }\n    \n    span {\n      display: inline-block;\n      margin: 0 ", "\n      width: auto;\n      margin: 0;\n      \n      ", " {\n        margin: 0 10px;\n      }\n    }\n    \n    select {\n      width: 100%;\n      \n      ", " {\n        width: auto;\n      }\n    }\n  } \n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledDropdownContainer = (0, _styledComponents["default"])('div')(_templateObject(), _govukColours.GREY_4, _constants.SPACING.SCALE_1, _constants.MEDIA_QUERIES.DESKTOP, _constants.MEDIA_QUERIES.DESKTOP, _constants.SPACING.SCALE_2, _constants.MEDIA_QUERIES.DESKTOP, _constants.MEDIA_QUERIES.DESKTOP);

var SelectFilter = function SelectFilter(_ref) {
  var filters = _ref.filters,
      onActivityTypeFilterChange = _ref.onActivityTypeFilterChange,
      value = _ref.value;
  return /*#__PURE__*/_react["default"].createElement(StyledDropdownContainer, null, /*#__PURE__*/_react["default"].createElement(_select["default"], {
    input: {
      defaultValue: value
    },
    name: "activity-types-filter",
    label: "Activity types",
    onChange: onActivityTypeFilterChange
  }, (0, _lodash.map)(filters, function (item, index) {
    return /*#__PURE__*/_react["default"].createElement("option", {
      key: "selectFilterKey_".concat(index),
      value: item.value
    }, item.label);
  })));
};

SelectFilter.propTypes = {
  filters: _propTypes["default"].array.isRequired,
  onActivityTypeFilterChange: _propTypes["default"].func.isRequired,
  value: _propTypes["default"].string.isRequired
};
var _default = SelectFilter;
exports["default"] = _default;