"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _axios = _interopRequireDefault(require("axios"));

var _pluralize = _interopRequireDefault(require("pluralize"));

function usePostcodeLookup(apiEndpoint) {
  function createAddressCount(addresses) {
    var addressCount = (0, _pluralize["default"])('address', addresses.length, true);
    return {
      address1: "".concat(addressCount, " found")
    };
  }

  return /*#__PURE__*/function () {
    var _findAddress = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(postcode) {
      var _yield$axios$get, data, addressCount;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _axios["default"].get("".concat(apiEndpoint, "/").concat(postcode));

            case 2:
              _yield$axios$get = _context.sent;
              data = _yield$axios$get.data;
              addressCount = createAddressCount(data);
              return _context.abrupt("return", [addressCount].concat((0, _toConsumableArray2["default"])(data)));

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    function findAddress(_x) {
      return _findAddress.apply(this, arguments);
    }

    return findAddress;
  }();
}

var _default = usePostcodeLookup;
exports["default"] = _default;