"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _constants = require("@govuk-react/constants");

var _visuallyHidden = _interopRequireDefault(require("@govuk-react/visually-hidden"));

var _govukColours = require("govuk-colours");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  border: ", ";\n  border-radius: 4px;\n  padding: 2px 4px;\n  font-size: ", ";\n  white-space: nowrap;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledBadge = (0, _styledComponents["default"])('span')(_templateObject(), function (_ref) {
  var borderColour = _ref.borderColour;
  return "2px solid ".concat(borderColour);
}, _constants.FONT_SIZE.SIZE_14);

var Badge = function Badge(_ref2) {
  var label = _ref2.label,
      borderColour = _ref2.borderColour,
      children = _ref2.children;
  return /*#__PURE__*/_react["default"].createElement(StyledBadge, {
    borderColour: borderColour
  }, label && /*#__PURE__*/_react["default"].createElement(_visuallyHidden["default"], null, label), children);
};

Badge.propTypes = {
  label: _propTypes["default"].string,
  borderColour: _propTypes["default"].string,
  children: _propTypes["default"].node.isRequired
};
Badge.defaultProps = {
  label: null,
  borderColour: _govukColours.GREY_2
};
var _default = Badge;
exports["default"] = _default;