"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _pluralize = _interopRequireDefault(require("pluralize"));

var _constants = require("@govuk-react/constants");

var _button = _interopRequireDefault(require("@govuk-react/button"));

var _CollectionHeaderRow = _interopRequireDefault(require("./CollectionHeaderRow"));

var _constants2 = _interopRequireDefault(require("./constants"));

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin-bottom: 0;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  width: 100%;\n  line-height: 36px;\n  ", " {\n    width: 0;\n    flex-grow: 1;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledInnerText = (0, _styledComponents["default"])('div')(_templateObject(), _constants.MEDIA_QUERIES.TABLET);
var StyledButton = (0, _styledComponents["default"])(_button["default"])(_templateObject2());

function getInnerText(totalItems, itemName) {
  var itemPlural = _pluralize["default"].plural(itemName);

  var itemPluralWithCount = (0, _pluralize["default"])(itemName, totalItems, true);

  if (totalItems === 0) {
    return "There are no ".concat(itemPlural, " to download");
  } else if (totalItems <= _constants2["default"]) {
    return "You can now download ".concat(itemPluralWithCount);
  } else {
    return "Filter to fewer than ".concat(_constants2["default"], " ").concat(itemPlural, " to download");
  }
}

function CollectionDownload(_ref) {
  var totalItems = _ref.totalItems,
      itemName = _ref.itemName,
      downloadUrl = _ref.downloadUrl;

  if (!downloadUrl) {
    return null;
  }

  var canDownload = totalItems > 0 && totalItems <= _constants2["default"];
  var innerText = getInnerText(totalItems, itemName);

  var actions = canDownload && /*#__PURE__*/_react["default"].createElement(StyledButton, {
    href: downloadUrl
  }, "Download");

  return /*#__PURE__*/_react["default"].createElement(_CollectionHeaderRow["default"], {
    actions: actions
  }, /*#__PURE__*/_react["default"].createElement(StyledInnerText, null, innerText));
}

CollectionDownload.propTypes = {
  totalItems: _propTypes["default"].number.isRequired,
  itemName: _propTypes["default"].string.isRequired,
  downloadUrl: _propTypes["default"].string
};
CollectionDownload.defaultProps = {
  downloadUrl: null
};
var _default = CollectionDownload;
exports["default"] = _default;