"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _button = _interopRequireDefault(require("@govuk-react/button"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _pluralize = _interopRequireDefault(require("pluralize"));

var _heading = require("@govuk-react/heading");

var _govukColours = require("govuk-colours");

var _constants = require("@govuk-react/constants");

var _CollectionHeaderRow = _interopRequireDefault(require("./CollectionHeaderRow"));

var _NumberUtils = _interopRequireDefault(require("../utils/NumberUtils"));

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-size: 36px;\n  font-weight: 600;\n  line-height: 1;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin-bottom: 0;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin-top: 0;\n  font-weight: normal;\n  font-size: ", "px;\n  margin-bottom: 0;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledHeaderText = (0, _styledComponents["default"])(_heading.H2)(_templateObject(), _constants.HEADING_SIZES.MEDIUM);

var StyledLink = _styledComponents["default"].a(_templateObject2());

var StyledResultCount = (0, _styledComponents["default"])('span')(_templateObject3());

function CollectionHeader(_ref) {
  var totalItems = _ref.totalItems,
      itemName = _ref.itemName,
      addItemUrl = _ref.addItemUrl;

  var formattedTotal = _NumberUtils["default"].decimal(totalItems);

  var counterSuffix = (0, _pluralize["default"])(itemName, totalItems);

  var actions = addItemUrl && /*#__PURE__*/_react["default"].createElement(_button["default"], {
    as: StyledLink,
    href: addItemUrl,
    buttonColour: _govukColours.GREY_3,
    buttonTextColour: _govukColours.BLACK
  }, "Add ", itemName);

  return /*#__PURE__*/_react["default"].createElement(_CollectionHeaderRow["default"], {
    primary: true,
    actions: actions
  }, /*#__PURE__*/_react["default"].createElement(StyledHeaderText, null, /*#__PURE__*/_react["default"].createElement(StyledResultCount, null, formattedTotal), " ".concat(counterSuffix)));
}

CollectionHeader.propTypes = {
  totalItems: _propTypes["default"].number.isRequired,
  itemName: _propTypes["default"].string.isRequired,
  addItemUrl: _propTypes["default"].string
};
CollectionHeader.defaultProps = {
  addItemUrl: null
};
var _default = CollectionHeader;
exports["default"] = _default;