"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _govukColours = require("govuk-colours");

var _constants = require("@govuk-react/constants");

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  text-align: right;\n  width: 100%;\n  ", " {\n    width: 0;\n    flex-grow: 1;\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  display: flex;\n  flex-flow: row wrap;\n  font-size: ", ";\n  padding: ", " 0;\n  border-bottom: ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledRowWrapper = (0, _styledComponents["default"])('div')(_templateObject(), _constants.FONT_SIZE.SIZE_16, _constants.SPACING.SCALE_2, function (_ref) {
  var primary = _ref.primary;
  return primary ? "".concat(_constants.SPACING.SCALE_1, " solid ").concat(_govukColours.BLACK) : "1px solid ".concat(_govukColours.GREY_2);
});
var StyledActions = (0, _styledComponents["default"])('div')(_templateObject2(), _constants.MEDIA_QUERIES.TABLET);

function CollectionHeaderRow(_ref2) {
  var primary = _ref2.primary,
      actions = _ref2.actions,
      children = _ref2.children;
  return /*#__PURE__*/_react["default"].createElement(StyledRowWrapper, {
    primary: primary
  }, children, actions && /*#__PURE__*/_react["default"].createElement(StyledActions, null, actions));
}

CollectionHeaderRow.propTypes = {
  primary: _propTypes["default"].bool,
  actions: _propTypes["default"].node,
  children: _propTypes["default"].node.isRequired
};
CollectionHeaderRow.defaultProps = {
  primary: false,
  actions: null
};
var _default = CollectionHeaderRow;
exports["default"] = _default;