"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _heading = require("@govuk-react/heading");

var _link = _interopRequireDefault(require("@govuk-react/link"));

var _constants = require("@govuk-react/constants");

var _govukColours = require("govuk-colours");

var _details = _interopRequireDefault(require("@govuk-react/details"));

var _Metadata = _interopRequireDefault(require("../metadata/Metadata"));

var _Badge = _interopRequireDefault(require("../badge/Badge"));

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin: ", " 0 0 0;\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-size: 14px;\n  line-height: 20px;\n  color: #6f777b;\n  font-weight: normal;\n  margin: -", " 0 ", " 0;\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  & > a:link,\n  a:visited,\n  a:hover,\n  a:active {\n    text-decoration: none;\n  }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-size: ", "px;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  float: right;\n  & > * {\n    margin-right: ", ";\n    &:last-child {\n      margin-right: 0;\n    }\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  border-bottom: 1px solid ", ";\n  padding: ", " 0;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var ItemWrapper = (0, _styledComponents["default"])('div')(_templateObject(), _govukColours.GREY_2, _constants.SPACING.SCALE_3);
var StyledBadgesWrapper = (0, _styledComponents["default"])('div')(_templateObject2(), _constants.SPACING.SCALE_1);
var StyledHeader = (0, _styledComponents["default"])(_heading.H3)(_templateObject3(), _constants.HEADING_SIZES.SMALL);
var StyledLinkHeader = (0, _styledComponents["default"])(StyledHeader)(_templateObject4());
var StyledSubheading = (0, _styledComponents["default"])('h4')(_templateObject5(), _constants.SPACING.SCALE_3, _constants.SPACING.SCALE_2);
var StyledDetails = (0, _styledComponents["default"])(_details["default"])(_templateObject6(), _constants.SPACING.SCALE_3);

function CollectionItem(_ref) {
  var headingUrl = _ref.headingUrl,
      headingText = _ref.headingText,
      subheading = _ref.subheading,
      badges = _ref.badges,
      metadata = _ref.metadata,
      type = _ref.type;
  var summaryMessage = type ? "View ".concat(type, " details") : 'View details';
  return /*#__PURE__*/_react["default"].createElement(ItemWrapper, null, badges && /*#__PURE__*/_react["default"].createElement(StyledBadgesWrapper, null, badges.map(function (badge) {
    return /*#__PURE__*/_react["default"].createElement(_Badge["default"], {
      key: badge.text,
      borderColour: badge.borderColour
    }, badge.text);
  })), headingUrl ? /*#__PURE__*/_react["default"].createElement(StyledLinkHeader, null, /*#__PURE__*/_react["default"].createElement(_link["default"], {
    href: headingUrl
  }, headingText)) : /*#__PURE__*/_react["default"].createElement(StyledHeader, null, headingText), /*#__PURE__*/_react["default"].createElement(StyledSubheading, null, subheading), metadata && metadata.length > 4 ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(StyledDetails, {
    summary: summaryMessage
  }, /*#__PURE__*/_react["default"].createElement(_Metadata["default"], {
    rows: metadata
  }))) : /*#__PURE__*/_react["default"].createElement(_Metadata["default"], {
    rows: metadata
  }));
}

CollectionItem.propTypes = {
  headingUrl: _propTypes["default"].string,
  headingText: _propTypes["default"].string.isRequired,
  subheading: _propTypes["default"].string,
  badges: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    text: _propTypes["default"].string,
    borderColour: _propTypes["default"].string
  })),
  metadata: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].string.isRequired,
    value: _propTypes["default"].node.isRequired
  })),
  type: _propTypes["default"].string
};
CollectionItem.defaultProps = {
  badges: null,
  subheading: null,
  metadata: null,
  headingUrl: null,
  type: null
};
var _default = CollectionItem;
exports["default"] = _default;