"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Pagination = _interopRequireDefault(require("../pagination/Pagination"));

var _CollectionHeader = _interopRequireDefault(require("./CollectionHeader"));

var _CollectionDownload = _interopRequireDefault(require("./CollectionDownload"));

var _CollectionItem = _interopRequireDefault(require("./CollectionItem"));

/* eslint-disable react/no-array-index-key */
// this is because there isn't necessarily a unique id to use as the key
function CollectionList(_ref) {
  var totalItems = _ref.totalItems,
      itemName = _ref.itemName,
      addItemUrl = _ref.addItemUrl,
      downloadUrl = _ref.downloadUrl,
      items = _ref.items,
      onPageClick = _ref.onPageClick,
      getPageUrl = _ref.getPageUrl,
      activePage = _ref.activePage,
      itemsPerPage = _ref.itemsPerPage;
  var totalPages = Math.ceil(totalItems / itemsPerPage);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_CollectionHeader["default"], {
    totalItems: totalItems,
    itemName: itemName,
    addItemUrl: addItemUrl
  }), /*#__PURE__*/_react["default"].createElement(_CollectionDownload["default"], {
    totalItems: totalItems,
    itemName: itemName,
    downloadUrl: downloadUrl
  }), items.map(function (_ref2, index) {
    var headingText = _ref2.headingText,
        headingUrl = _ref2.headingUrl,
        subheading = _ref2.subheading,
        badges = _ref2.badges,
        metadata = _ref2.metadata,
        type = _ref2.type;
    return /*#__PURE__*/_react["default"].createElement(_CollectionItem["default"], {
      key: [totalItems, activePage, index].join('-'),
      headingUrl: headingUrl,
      headingText: headingText,
      subheading: subheading,
      badges: badges,
      metadata: metadata,
      type: type
    });
  }), /*#__PURE__*/_react["default"].createElement(_Pagination["default"], {
    totalPages: totalPages,
    activePage: activePage,
    onPageClick: onPageClick,
    getPageUrl: getPageUrl
  }));
}

CollectionList.propTypes = {
  totalItems: _propTypes["default"].number,
  itemName: _propTypes["default"].string,
  addItemUrl: _propTypes["default"].string,
  downloadUrl: _propTypes["default"].string,
  items: _propTypes["default"].array,
  onPageClick: _propTypes["default"].func,
  getPageUrl: _propTypes["default"].func,
  activePage: _propTypes["default"].number,
  itemsPerPage: _propTypes["default"].number
};
CollectionList.defaultProps = {
  totalItems: 0,
  itemName: 'result',
  addItemUrl: null,
  downloadUrl: null,
  items: [],
  onPageClick: null,
  getPageUrl: function getPageUrl(page) {
    return "#page-".concat(page);
  },
  activePage: 1,
  itemsPerPage: 10
};
var _default = CollectionList;
exports["default"] = _default;