"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _button = _interopRequireDefault(require("@govuk-react/button"));

var _link = _interopRequireDefault(require("@govuk-react/link"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _govukColours = require("govuk-colours");

var _FormStateful = _interopRequireDefault(require("../forms/elements/FormStateful"));

var _FieldRadios = _interopRequireDefault(require("../forms/elements/FieldRadios"));

var _FieldInput = _interopRequireDefault(require("../forms/elements/FieldInput"));

var _FormActions = _interopRequireDefault(require("../forms/elements/FormActions"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var AddRemoveFromListForm = function AddRemoveFromListForm(_ref) {
  var list = _ref.list,
      onSubmitHandler = _ref.onSubmitHandler,
      createNewListUrl = _ref.createNewListUrl,
      cancelLinkUrl = _ref.cancelLinkUrl;
  var companyId = list.companyId,
      companyLists = list.companyLists;
  var initState = companyLists.reduce(function (obj, _ref2) {
    var listId = _ref2.listId,
        isAdded = _ref2.isAdded;
    return _objectSpread(_objectSpread({}, obj), {}, (0, _defineProperty2["default"])({}, listId, isAdded));
  }, {});
  return /*#__PURE__*/_react["default"].createElement(_FormStateful["default"], {
    initialValues: initState,
    onSubmit: onSubmitHandler
  }, /*#__PURE__*/_react["default"].createElement(_FieldInput["default"], {
    name: "company",
    type: "hidden",
    value: companyId
  }), companyLists.map(function (_ref3) {
    var listId = _ref3.listId,
        listName = _ref3.listName;
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: listId
    }, /*#__PURE__*/_react["default"].createElement(_FieldRadios["default"], {
      name: listId,
      legend: "On the \"".concat(listName, "\" list"),
      options: [{
        label: 'Yes',
        value: 'yes',
        inline: 'true'
      }, {
        label: 'No',
        value: 'no',
        inline: 'true'
      }]
    }));
  }), /*#__PURE__*/_react["default"].createElement(_button["default"], {
    as: _link["default"],
    href: createNewListUrl,
    buttonColour: _govukColours.GREY_3,
    buttonTextColour: _govukColours.TEXT_COLOUR
  }, "Create a new list"), /*#__PURE__*/_react["default"].createElement(_FormActions["default"], null, /*#__PURE__*/_react["default"].createElement(_button["default"], null, "Save"), /*#__PURE__*/_react["default"].createElement(_link["default"], {
    href: cancelLinkUrl
  }, "Cancel")));
};

AddRemoveFromListForm.propTypes = {
  onSubmitHandler: _propTypes["default"].func.isRequired,
  list: _propTypes["default"].object.isRequired,
  createNewListUrl: _propTypes["default"].string.isRequired,
  cancelLinkUrl: _propTypes["default"].string.isRequired
};
var _default = AddRemoveFromListForm;
exports["default"] = _default;