"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _button = _interopRequireDefault(require("@govuk-react/button"));

var _link = _interopRequireDefault(require("@govuk-react/link"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormStateful = _interopRequireDefault(require("../forms/elements/FormStateful"));

var _FieldInput = _interopRequireDefault(require("../forms/elements/FieldInput"));

var _FormActions = _interopRequireDefault(require("../forms/elements/FormActions"));

var CreateListForm = function CreateListForm(_ref) {
  var name = _ref.name,
      label = _ref.label,
      hint = _ref.hint,
      maxLength = _ref.maxLength,
      onSubmitHandler = _ref.onSubmitHandler,
      cancelUrl = _ref.cancelUrl;
  var cancelLink = "".concat(cancelUrl);
  return /*#__PURE__*/_react["default"].createElement(_FormStateful["default"], {
    onSubmit: onSubmitHandler
  }, /*#__PURE__*/_react["default"].createElement(_FieldInput["default"], {
    name: name,
    type: "text",
    label: label,
    required: "Enter a name for your list",
    hint: hint,
    validate: function validate(value) {
      return value && value.length > maxLength ? "Enter list name which is no longer than ".concat(maxLength, " characters") : null;
    }
  }), /*#__PURE__*/_react["default"].createElement(_FormActions["default"], null, /*#__PURE__*/_react["default"].createElement(_button["default"], null, "Create list"), /*#__PURE__*/_react["default"].createElement(_link["default"], {
    href: cancelLink
  }, "Cancel")));
};

CreateListForm.propTypes = {
  onSubmitHandler: _propTypes["default"].func.isRequired,
  name: _propTypes["default"].string.isRequired,
  hint: _propTypes["default"].string,
  cancelUrl: _propTypes["default"].string.isRequired,
  label: _propTypes["default"].string.isRequired,
  maxLength: _propTypes["default"].number.isRequired
};
CreateListForm.defaultProps = {
  hint: ''
};
var _default = CreateListForm;
exports["default"] = _default;