"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _govukColours = require("govuk-colours");

var _button = _interopRequireDefault(require("@govuk-react/button"));

var _errorSummary = _interopRequireDefault(require("@govuk-react/error-summary"));

var _insetText = _interopRequireDefault(require("@govuk-react/inset-text"));

var _link = _interopRequireDefault(require("@govuk-react/link"));

var _listItem = _interopRequireDefault(require("@govuk-react/list-item"));

var _paragraph = _interopRequireDefault(require("@govuk-react/paragraph"));

var _unorderedList = _interopRequireDefault(require("@govuk-react/unordered-list"));

var _pluralize = _interopRequireDefault(require("pluralize"));

var _FormActions = _interopRequireDefault(require("../forms/elements/FormActions"));

var DeleteCompanyListSection = function DeleteCompanyListSection(_ref) {
  var companyList = _ref.companyList,
      errorMessage = _ref.errorMessage,
      onDelete = _ref.onDelete,
      returnUrl = _ref.returnUrl;
  var companyCountText = (0, _pluralize["default"])('company', companyList.item_count, true);
  return /*#__PURE__*/_react["default"].createElement("div", null, errorMessage && /*#__PURE__*/_react["default"].createElement(_errorSummary["default"], {
    heading: "There was an error deleting this list",
    description: errorMessage,
    errors: []
  }), /*#__PURE__*/_react["default"].createElement(_paragraph["default"], null, "Deleting this list will remove all companies from this list. These companies will remain on any other lists."), /*#__PURE__*/_react["default"].createElement(_insetText["default"], null, /*#__PURE__*/_react["default"].createElement(_unorderedList["default"], {
    listStyleType: "none",
    mb: 0
  }, /*#__PURE__*/_react["default"].createElement(_listItem["default"], null, /*#__PURE__*/_react["default"].createElement("strong", null, companyList.name)), /*#__PURE__*/_react["default"].createElement(_listItem["default"], null, companyCountText))), /*#__PURE__*/_react["default"].createElement(_FormActions["default"], null, /*#__PURE__*/_react["default"].createElement(_button["default"], {
    buttonColour: _govukColours.RED,
    onClick: onDelete
  }, "Delete list"), /*#__PURE__*/_react["default"].createElement(_link["default"], {
    href: returnUrl
  }, "Return without deleting")));
};

DeleteCompanyListSection.propTypes = {
  companyList: _propTypes["default"].object.isRequired,
  errorMessage: _propTypes["default"].string,
  onDelete: _propTypes["default"].func.isRequired,
  returnUrl: _propTypes["default"].string.isRequired
};
DeleteCompanyListSection.defaultProps = {
  errorMessage: null
};
var _default = DeleteCompanyListSection;
exports["default"] = _default;