"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _heading = require("@govuk-react/heading");

var _link = _interopRequireDefault(require("@govuk-react/link"));

var _select = _interopRequireDefault(require("@govuk-react/select"));

var _constants = require("@govuk-react/constants");

var _useMyCompaniesContext = _interopRequireDefault(require("./useMyCompaniesContext"));

var _constants2 = require("./constants");

var StyledRoot = _styledComponents["default"].div({
  display: 'flex',
  alignItems: 'baseline'
});

var StyledHeadline = (0, _styledComponents["default"])(_heading.H2)({
  flexGrow: 1
});
var StyledListName = (0, _styledComponents["default"])(_heading.H3)({
  marginRight: _constants.SPACING.SCALE_2
});
var StyledSelect = (0, _styledComponents["default"])(_select["default"])({
  display: 'flex',
  flexDirection: 'row',
  alignItems: 'baseline',
  marginRight: _constants.SPACING.SCALE_2,
  span: {
    marginRight: _constants.SPACING.SCALE_2
  },
  // We need to override the select style because it has a hardcoded 50% width.
  select: {
    width: 'initial',
    minWidth: 200
  }
});

var _default = function _default() {
  var _useMyCompaniesContex = (0, _useMyCompaniesContext["default"])(),
      _useMyCompaniesContex2 = _useMyCompaniesContex.state,
      lists = _useMyCompaniesContex2.lists,
      selectedIdx = _useMyCompaniesContex2.selectedIdx,
      dispatch = _useMyCompaniesContex.dispatch,
      _useMyCompaniesContex3 = _useMyCompaniesContex.deleteListPropsAccessor,
      deleteListPropsAccessor = _useMyCompaniesContex3 === void 0 ? function () {
    return {};
  } : _useMyCompaniesContex3;

  return /*#__PURE__*/_react["default"].createElement(StyledRoot, null, /*#__PURE__*/_react["default"].createElement(StyledHeadline, {
    size: _constants.LEVEL_SIZE[3]
  }, "My Companies Lists"), lists.length ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, lists.length === 1 ? /*#__PURE__*/_react["default"].createElement(StyledListName, null, lists[0].name) : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(StyledSelect, {
    label: "View list",
    input: {
      onChange: function onChange(e) {
        return dispatch({
          type: _constants2.LIST_CHANGE,
          idx: e.target.value
        });
      }
    }
  }, lists.map(function (_ref, idx) {
    var name = _ref.name;
    return /*#__PURE__*/_react["default"].createElement("option", {
      key: idx,
      value: idx
    }, name);
  }))), /*#__PURE__*/_react["default"].createElement(_link["default"], deleteListPropsAccessor(lists[selectedIdx]), "Delete this list")) : null);
};

exports["default"] = _default;