"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _select = require("@govuk-react/select");

var _input = _interopRequireDefault(require("@govuk-react/input"));

var _labelText = _interopRequireDefault(require("@govuk-react/label-text"));

var _label = _interopRequireDefault(require("@govuk-react/label"));

var _constants = require("@govuk-react/constants");

var _useMyCompaniesContext = _interopRequireDefault(require("./useMyCompaniesContext"));

var _constants2 = require("./constants");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  display: flex;\n  justify-content: flex-end;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledSelectInput = (0, _styledComponents["default"])(_select.SelectInput)((0, _defineProperty2["default"])({}, _constants.MEDIA_QUERIES.LARGESCREEN, {
  width: 'auto'
}));
var StyledInput = (0, _styledComponents["default"])(_input["default"])({
  width: 200,
  marginRight: _constants.SPACING.SCALE_6
});

var StyledContainer = _styledComponents["default"].div(_templateObject());

var StyledLabel = (0, _styledComponents["default"])(_label["default"])({
  display: 'flex',
  flexDirection: 'row',
  alignItems: 'baseline'
});
var StyledLabelText = (0, _styledComponents["default"])(_labelText["default"])({
  marginRight: _constants.SPACING.SCALE_2
});

var InlineLabel = function InlineLabel(_ref) {
  var text = _ref.text,
      children = _ref.children;
  return /*#__PURE__*/_react["default"].createElement(StyledLabel, null, /*#__PURE__*/_react["default"].createElement(StyledLabelText, null, text), children);
};

InlineLabel.propTypes = {
  text: _propTypes["default"].string.isRequired,
  children: _propTypes["default"].node
};
InlineLabel.defaultProps = {
  children: null
};

function MyCompaniesFilters() {
  var _useMyCompaniesContex = (0, _useMyCompaniesContext["default"])(),
      dispatch = _useMyCompaniesContex.dispatch;

  return /*#__PURE__*/_react["default"].createElement(StyledContainer, null, /*#__PURE__*/_react["default"].createElement(InlineLabel, {
    text: "Search this list"
  }, /*#__PURE__*/_react["default"].createElement(StyledInput, {
    placeholder: "Company name",
    onChange: function onChange(e) {
      return dispatch({
        type: _constants2.FILTER_CHANGE,
        filter: e.target.value
      });
    }
  })), /*#__PURE__*/_react["default"].createElement(InlineLabel, {
    text: "Sort by"
  }, /*#__PURE__*/_react["default"].createElement(StyledSelectInput, {
    onChange: function onChange(e) {
      return dispatch({
        type: _constants2.ORDER_CHANGE,
        sortBy: e.target.value
      });
    }
  }, /*#__PURE__*/_react["default"].createElement("option", {
    value: "recent"
  }, "Recent interaction"), /*#__PURE__*/_react["default"].createElement("option", {
    value: "least-recent"
  }, "Least recent interaction"), /*#__PURE__*/_react["default"].createElement("option", {
    value: "alphabetical"
  }, "Company name A-Z"))));
}

var _default = MyCompaniesFilters;
exports["default"] = _default;