"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = require("lodash");

var _moment = _interopRequireDefault(require("moment"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _reactLinesEllipsis = _interopRequireDefault(require("react-lines-ellipsis"));

var _lib = require("@govuk-react/lib");

var _table = _interopRequireDefault(require("@govuk-react/table"));

var _link = _interopRequireDefault(require("@govuk-react/link"));

var _govukColours = require("govuk-colours");

var _constants = require("@govuk-react/constants");

var _button = _interopRequireDefault(require("@govuk-react/button"));

var _useMyCompaniesContext = _interopRequireDefault(require("./useMyCompaniesContext"));

var _MyCompaniesFilters = _interopRequireDefault(require("./MyCompaniesFilters"));

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin-bottom: 0;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  white-space: nowrap;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledCellHeader = (0, _styledComponents["default"])(_table["default"].CellHeader)(_lib.typography.font({
  size: 14,
  weight: 'bold'
}), (0, _defineProperty2["default"])({}, _constants.MEDIA_QUERIES.DESKTOP, {
  overflow: 'hidden',
  'white-space': 'nowrap'
}));
var StyledButtonTableCell = (0, _styledComponents["default"])(_table["default"].CellHeader)(_templateObject());
var StyledDateCell = (0, _styledComponents["default"])(_table["default"].Cell)(_lib.typography.font({
  size: 14
}), {
  color: _govukColours.GREY_1
});

var StyledLink = _styledComponents["default"].a(_templateObject2());

function sortCompanies(companies, sortType) {
  var sort = {
    recent: (0, _lodash.orderBy)(companies, [function (c) {
      return c.latestInteraction.date || '';
    }], ['desc']),
    'least-recent': (0, _lodash.orderBy)(companies, [function (c) {
      return c.latestInteraction.date || '';
    }], ['asc']),
    alphabetical: (0, _lodash.orderBy)(companies, [function (c) {
      return c.company.name;
    }], ['asc'])
  };
  return sort[sortType];
}

var filterCompanyName = function filterCompanyName(companies, filterText) {
  return filterText.length ? companies.filter(function (c) {
    return c.company.name.toLowerCase().includes(filterText.toLowerCase());
  }) : companies;
};

function MyCompaniesTable() {
  var _useMyCompaniesContex = (0, _useMyCompaniesContext["default"])(),
      _useMyCompaniesContex2 = _useMyCompaniesContex.state,
      lists = _useMyCompaniesContex2.lists,
      selectedIdx = _useMyCompaniesContex2.selectedIdx,
      sortBy = _useMyCompaniesContex2.sortBy,
      filter = _useMyCompaniesContex2.filter,
      _useMyCompaniesContex3 = _useMyCompaniesContex.addInteractionPropsAccessor,
      addInteractionPropsAccessor = _useMyCompaniesContex3 === void 0 ? function () {
    return {};
  } : _useMyCompaniesContex3;

  var list = lists[selectedIdx];
  var filteredSortedCompanies = sortCompanies(filterCompanyName(list.companies, filter), sortBy);

  var header = /*#__PURE__*/_react["default"].createElement(_table["default"].Row, null, /*#__PURE__*/_react["default"].createElement(StyledCellHeader, null, "Company name"), /*#__PURE__*/_react["default"].createElement(StyledCellHeader, null, "Last interaction"), /*#__PURE__*/_react["default"].createElement(StyledCellHeader, {
    colSpan: "2"
  }, "\xA0"));

  var rows = filteredSortedCompanies.map(function (_ref) {
    var company = _ref.company,
        latestInteraction = _ref.latestInteraction;
    return /*#__PURE__*/_react["default"].createElement(_table["default"].Row, {
      key: company.id
    }, /*#__PURE__*/_react["default"].createElement(_table["default"].Cell, {
      setWidth: "25%"
    }, /*#__PURE__*/_react["default"].createElement(_link["default"], {
      href: "companies/".concat(company.id)
    }, /*#__PURE__*/_react["default"].createElement(_reactLinesEllipsis["default"], {
      text: company.name,
      maxLine: "2",
      ellipsis: "...",
      trimRight: true,
      basedOn: "words"
    }))), /*#__PURE__*/_react["default"].createElement(StyledDateCell, {
      setWidth: "15%"
    }, latestInteraction.date ? (0, _moment["default"])(latestInteraction.date).format('D MMM YYYY') : '-'), /*#__PURE__*/_react["default"].createElement(_table["default"].Cell, {
      setWidth: "50%"
    }, latestInteraction.id ? /*#__PURE__*/_react["default"].createElement(_link["default"], {
      href: "interactions/".concat(latestInteraction.id)
    }, /*#__PURE__*/_react["default"].createElement(_reactLinesEllipsis["default"], {
      text: latestInteraction.subject,
      maxLine: "2",
      ellipsis: "...",
      trimRight: true,
      basedOn: "words"
    })) : latestInteraction.subject), /*#__PURE__*/_react["default"].createElement(StyledButtonTableCell, null, /*#__PURE__*/_react["default"].createElement(_button["default"], (0, _extends2["default"])({
      as: StyledLink,
      buttonColour: _govukColours.GREY_3,
      buttonTextColour: _govukColours.TEXT_COLOUR
    }, addInteractionPropsAccessor(company)), "Add interaction")));
  });
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, list.companies.length > 1 && /*#__PURE__*/_react["default"].createElement(_MyCompaniesFilters["default"], null), /*#__PURE__*/_react["default"].createElement(_table["default"], {
    head: header
  }, rows));
}

var _default = MyCompaniesTable;
exports["default"] = _default;