"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _hintText = _interopRequireDefault(require("@govuk-react/hint-text"));

var _constants = require("@govuk-react/constants");

var _govukColours = require("govuk-colours");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _useMyCompaniesContext = _interopRequireDefault(require("./useMyCompaniesContext"));

var _MyCompaniesTable = _interopRequireDefault(require("./MyCompaniesTable"));

var _ListSelector = _interopRequireDefault(require("./ListSelector"));

var StyledDiv = _styledComponents["default"].div({
  borderTop: "".concat(_constants.BORDER_WIDTH_MOBILE, " solid ").concat(_govukColours.GREY_2),
  paddingTop: _constants.SPACING.SCALE_3
});

var EmptyListMsg = function EmptyListMsg() {
  return /*#__PURE__*/_react["default"].createElement(_hintText["default"], null, "You have not added any companies to your list.", /*#__PURE__*/_react["default"].createElement("br", null), "You can add companies to this list from a company page, and only you can see this list.");
};

var NoListsMsg = function NoListsMsg() {
  return /*#__PURE__*/_react["default"].createElement(_hintText["default"], null, "You have not yet created any lists with companies.", /*#__PURE__*/_react["default"].createElement("br", null), "You can add companies to lists from a company page, and only you can see these lists.");
};

function MyCompaniesTile() {
  var _useMyCompaniesContex = (0, _useMyCompaniesContext["default"])(),
      _useMyCompaniesContex2 = _useMyCompaniesContex.state,
      lists = _useMyCompaniesContex2.lists,
      selectedIdx = _useMyCompaniesContex2.selectedIdx;

  var hasLists = lists.length;
  var list = lists[selectedIdx];
  var hasCompanies = list && list.companies && list.companies.length;
  return /*#__PURE__*/_react["default"].createElement(StyledDiv, null, /*#__PURE__*/_react["default"].createElement(_ListSelector["default"], null), hasLists ? hasCompanies ? /*#__PURE__*/_react["default"].createElement(_MyCompaniesTable["default"], null) : /*#__PURE__*/_react["default"].createElement(EmptyListMsg, null) : /*#__PURE__*/_react["default"].createElement(NoListsMsg, null));
}

var _default = MyCompaniesTile;
exports["default"] = _default;