"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.reducer = exports.filterCompanyName = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _lodash = require("lodash");

var _react = require("react");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _constate = _interopRequireDefault(require("constate"));

var _constants = require("./constants");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var filterCompanyName = function filterCompanyName(companies, filterText) {
  return filterText.length ? companies.filter(function (c) {
    return c.company.name.toLowerCase().includes(filterText.toLowerCase());
  }) : companies;
};

exports.filterCompanyName = filterCompanyName;
var defaultState = {
  lists: [],
  selectedIdx: 0,
  sortBy: 'recent',
  filter: ''
};

var reducer = function reducer(state, _ref) {
  var type = _ref.type,
      action = (0, _objectWithoutProperties2["default"])(_ref, ["type"]);

  switch (type) {
    case _constants.LIST_CHANGE:
      return _objectSpread(_objectSpread({}, state), {}, {
        selectedIdx: action.idx
      });

    case _constants.FILTER_CHANGE:
      return _objectSpread(_objectSpread({}, state), {}, {
        filter: action.filter
      });

    case _constants.ORDER_CHANGE:
      return _objectSpread(_objectSpread({}, state), {}, {
        sortBy: action.sortBy
      });

    default:
      return state;
  }
}; // We are unpacking children here just to remove them from initialState.


exports.reducer = reducer;
var useMyCompaniesContext = (0, _constate["default"])(function (_ref2) {
  var children = _ref2.children,
      deleteListPropsAccessor = _ref2.deleteListPropsAccessor,
      addInteractionPropsAccessor = _ref2.addInteractionPropsAccessor,
      rest = (0, _objectWithoutProperties2["default"])(_ref2, ["children", "deleteListPropsAccessor", "addInteractionPropsAccessor"]);
  var initialState = (0, _lodash.pick)(rest, ['lists', 'selectedIdx', 'sortBy', 'filter']);

  var _useReducer = (0, _react.useReducer)(reducer, _objectSpread(_objectSpread(_objectSpread({}, defaultState), initialState), {}, {
    // Reducer assumes the list of company lists is sorted.
    lists: (0, _lodash.orderBy)(initialState.lists, 'name')
  })),
      _useReducer2 = (0, _slicedToArray2["default"])(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  return {
    state: state,
    dispatch: dispatch,
    deleteListPropsAccessor: deleteListPropsAccessor,
    addInteractionPropsAccessor: addInteractionPropsAccessor
  };
});
var idNameShape = {
  name: _propTypes["default"].string.isRequired,
  id: _propTypes["default"].string.isRequired
};
useMyCompaniesContext.Provider.propTypes = {
  lists: _propTypes["default"].arrayOf(_propTypes["default"].shape(_objectSpread(_objectSpread({}, idNameShape), {}, {
    companies: _propTypes["default"].arrayOf(_propTypes["default"].shape({
      company: _propTypes["default"].shape(_objectSpread({}, idNameShape)).isRequired,
      latestInteraction: _propTypes["default"].shape({
        id: _propTypes["default"].string,
        date: _propTypes["default"].string,
        subject: _propTypes["default"].string
      })
    }))
  })))
};
var _default = useMyCompaniesContext;
exports["default"] = _default;