"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = require("lodash");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _constants = require("@govuk-react/constants");

var _govukColours = require("govuk-colours");

var _heading = require("@govuk-react/heading");

var _insetText = _interopRequireDefault(require("@govuk-react/inset-text"));

var _Metadata = _interopRequireDefault(require("../metadata/Metadata"));

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  & {\n    margin-top: ", ";\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-size: ", ";\n  margin: 0 0 ", ";\n  ", " {\n    font-size: ", ";\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin-bottom: ", ";\n  padding: ", ";\n  border: 1px solid ", ";\n  ", ";\n\n  ", "\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var KEY_ENTER = 13;
var StyledEntity = (0, _styledComponents["default"])('div')(_templateObject(), _constants.SPACING.SCALE_2, _constants.SPACING.SCALE_2, _govukColours.GREY_2, _constants.FOCUSABLE, function (_ref) {
  var isClickable = _ref.isClickable;
  return isClickable && "\n    cursor: pointer;\n\n    h3 {\n      color: ".concat(_govukColours.LINK_COLOUR, ";\n    }\n\n    &:hover {\n      border: 1px solid ").concat(_govukColours.LINK_HOVER_COLOUR, ";\n      background-color: ").concat(_govukColours.GREY_4, ";\n\n      & > h3 {\n        color: ").concat(_govukColours.LINK_HOVER_COLOUR, ";\n      }\n    }\n  ");
});
var StyledHeading = (0, _styledComponents["default"])(_heading.H3)(_templateObject2(), _constants.FONT_SIZE.SIZE_16, _constants.SPACING.SCALE_2, _constants.MEDIA_QUERIES.TABLET, _constants.FONT_SIZE.SIZE_19);
var StyledInsetText = (0, _styledComponents["default"])(_insetText["default"])(_templateObject3(), _constants.SPACING.SCALE_2);

var EntityListItem = function EntityListItem(_ref2) {
  var id = _ref2.id,
      onEntityClick = _ref2.onEntityClick,
      data = _ref2.data,
      text = _ref2.text,
      heading = _ref2.heading,
      meta = _ref2.meta;
  return /*#__PURE__*/_react["default"].createElement(StyledEntity, {
    key: "entity_".concat(id),
    tabIndex: onEntityClick ? 0 : undefined,
    onClick: function onClick() {
      return onEntityClick && onEntityClick(data);
    },
    onKeyDown: function onKeyDown(e) {
      return onEntityClick && e.keyCode === KEY_ENTER && onEntityClick(data);
    },
    isClickable: onEntityClick
  }, heading && /*#__PURE__*/_react["default"].createElement(StyledHeading, null, heading), !(0, _lodash.isEmpty)(meta) && /*#__PURE__*/_react["default"].createElement(_Metadata["default"], {
    rows: meta
  }), text && /*#__PURE__*/_react["default"].createElement(StyledInsetText, null, text));
};

EntityListItem.propTypes = {
  id: _propTypes["default"].string.isRequired,
  onEntityClick: _propTypes["default"].func,
  data: _propTypes["default"].shape({}),
  text: _propTypes["default"].node,
  heading: _propTypes["default"].string,
  meta: _propTypes["default"].array
};
EntityListItem.defaultProps = {
  text: null,
  onEntityClick: null,
  data: {},
  heading: null,
  meta: []
};
var _default = EntityListItem;
exports["default"] = _default;