"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _axios = _interopRequireDefault(require("axios"));

var _lodash = require("lodash");

/* eslint-disable camelcase */
function getTradingNames(dnb_company) {
  return (0, _lodash.isEmpty)(dnb_company.trading_names) ? null : {
    label: 'Trading name(s)',
    value: dnb_company.trading_names.join(', ')
  };
}

function getAddress(dnb_company) {
  return {
    label: 'Location at',
    value: (0, _lodash.compact)([dnb_company.address_line_1, dnb_company.address_line_2, dnb_company.address_town, dnb_company.address_county, dnb_company.address_postcode]).join(', ')
  };
}

function useDnbSearch(apiEndpoint) {
  function transformCompanyRecord(record) {
    var dnb_company = record.dnb_company;
    return {
      id: dnb_company.duns_number,
      heading: dnb_company.primary_name,
      meta: (0, _lodash.compact)([getTradingNames(dnb_company), getAddress(dnb_company)]),
      data: record
    };
  }

  function findCompany(_x) {
    return _findCompany.apply(this, arguments);
  }

  function _findCompany() {
    _findCompany = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(filters) {
      var _yield$axios$post, data;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _axios["default"].post(apiEndpoint, filters);

            case 2:
              _yield$axios$post = _context.sent;
              data = _yield$axios$post.data;
              return _context.abrupt("return", data.results.map(transformCompanyRecord));

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _findCompany.apply(this, arguments);
  }

  return {
    findCompany: findCompany,
    transformCompanyRecord: transformCompanyRecord
  };
}

var _default = useDnbSearch;
exports["default"] = _default;