"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _checkbox = _interopRequireDefault(require("@govuk-react/checkbox"));

var _multiChoice = _interopRequireDefault(require("@govuk-react/multi-choice"));

var _useField2 = _interopRequireDefault(require("../hooks/useField"));

var _FieldWrapper = _interopRequireDefault(require("./FieldWrapper"));

var _useFormContext2 = _interopRequireDefault(require("../hooks/useFormContext"));

var FieldCheckboxes = function FieldCheckboxes(_ref) {
  var name = _ref.name,
      validate = _ref.validate,
      required = _ref.required,
      label = _ref.label,
      legend = _ref.legend,
      hint = _ref.hint,
      options = _ref.options,
      initialValue = _ref.initialValue;

  var _useField = (0, _useField2["default"])({
    name: name,
    validate: validate,
    required: required,
    initialValue: initialValue
  }),
      value = _useField.value,
      error = _useField.error,
      touched = _useField.touched,
      onBlur = _useField.onBlur;

  var _useFormContext = (0, _useFormContext2["default"])(),
      setFieldValue = _useFormContext.setFieldValue;

  var onChange = function onChange(e) {
    var _e$target = e.target,
        optionName = _e$target.name,
        checked = _e$target.checked;
    var newValue = Array.isArray(value) ? (0, _toConsumableArray2["default"])(value) : [];

    if (checked) {
      newValue.push(optionName);
    } else if (newValue.includes(optionName)) {
      newValue = newValue.filter(function (item) {
        return item !== optionName;
      });
    }

    setFieldValue(name, newValue);
  };

  return /*#__PURE__*/_react["default"].createElement(_FieldWrapper["default"], {
    name: name,
    label: label,
    legend: legend,
    hint: hint,
    error: error
  }, /*#__PURE__*/_react["default"].createElement(_multiChoice["default"], {
    meta: {
      error: error,
      touched: touched
    }
  }, options.map(function (_ref2) {
    var optionValue = _ref2.value,
        optionLabel = _ref2.label,
        children = _ref2.children,
        optionProps = (0, _objectWithoutProperties2["default"])(_ref2, ["value", "label", "children"]);
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: optionValue
    }, /*#__PURE__*/_react["default"].createElement(_checkbox["default"], (0, _extends2["default"])({
      key: optionValue,
      name: optionValue,
      checked: value.includes(optionValue),
      onChange: onChange,
      onBlur: onBlur
    }, optionProps), optionLabel), value.includes(optionValue) && !!children ? children : null);
  })));
};

FieldCheckboxes.propTypes = {
  name: _propTypes["default"].string.isRequired,
  validate: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].arrayOf(_propTypes["default"].func)]),
  required: _propTypes["default"].string,
  label: _propTypes["default"].node,
  legend: _propTypes["default"].node,
  hint: _propTypes["default"].node,
  initialValue: _propTypes["default"].arrayOf(_propTypes["default"].string),
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].string.isRequired,
    value: _propTypes["default"].string.isRequired,
    children: _propTypes["default"].node
  }))
};
FieldCheckboxes.defaultProps = {
  validate: null,
  required: null,
  label: null,
  legend: null,
  hint: null,
  initialValue: [],
  options: []
};
var _default = FieldCheckboxes;
exports["default"] = _default;