"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _radio = _interopRequireDefault(require("@govuk-react/radio"));

var _multiChoice = _interopRequireDefault(require("@govuk-react/multi-choice"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _useField2 = _interopRequireDefault(require("../hooks/useField"));

var _FieldWrapper = _interopRequireDefault(require("./FieldWrapper"));

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  ", "\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin-left: 55px;\n  clear: both;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledChildField = (0, _styledComponents["default"])('div')(_templateObject());
var StyledRadio = (0, _styledComponents["default"])(_radio["default"])(_templateObject2(), function (props) {
  return props.inline && "\n      float: left;\n      clear: none;\n    ";
});

var FieldRadios = function FieldRadios(_ref) {
  var name = _ref.name,
      validate = _ref.validate,
      required = _ref.required,
      label = _ref.label,
      legend = _ref.legend,
      hint = _ref.hint,
      inline = _ref.inline,
      initialValue = _ref.initialValue,
      options = _ref.options;

  var _useField = (0, _useField2["default"])({
    name: name,
    validate: validate,
    required: required,
    initialValue: initialValue
  }),
      value = _useField.value,
      error = _useField.error,
      touched = _useField.touched,
      onChange = _useField.onChange,
      onBlur = _useField.onBlur;

  return /*#__PURE__*/_react["default"].createElement(_FieldWrapper["default"], {
    name: name,
    label: label,
    legend: legend,
    hint: hint,
    error: error
  }, /*#__PURE__*/_react["default"].createElement(_multiChoice["default"], {
    meta: {
      error: error,
      touched: touched
    }
  }, options.map(function (_ref2) {
    var optionLabel = _ref2.label,
        optionValue = _ref2.value,
        optionChildren = _ref2.children,
        optionProps = (0, _objectWithoutProperties2["default"])(_ref2, ["label", "value", "children"]);
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      key: optionValue
    }, /*#__PURE__*/_react["default"].createElement(StyledRadio, (0, _extends2["default"])({
      inline: inline,
      value: optionValue,
      checked: value === optionValue,
      onChange: onChange,
      onBlur: onBlur,
      name: name
    }, optionProps), optionLabel), value === optionValue && optionChildren && /*#__PURE__*/_react["default"].createElement(StyledChildField, null, optionChildren));
  })));
};

FieldRadios.propTypes = {
  name: _propTypes["default"].string.isRequired,
  validate: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].arrayOf(_propTypes["default"].func)]),
  required: _propTypes["default"].string,
  label: _propTypes["default"].node,
  legend: _propTypes["default"].node,
  hint: _propTypes["default"].node,
  inline: _propTypes["default"].bool,
  initialValue: _propTypes["default"].string,
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].string.isRequired,
    value: _propTypes["default"].string.isRequired,
    hint: _propTypes["default"].node,
    children: _propTypes["default"].node
  }))
};
FieldRadios.defaultProps = {
  validate: null,
  required: null,
  label: null,
  legend: null,
  hint: null,
  inline: false,
  initialValue: '',
  options: []
};
var _default = FieldRadios;
exports["default"] = _default;