"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _select = _interopRequireDefault(require("@govuk-react/select"));

var _useField2 = _interopRequireDefault(require("../hooks/useField"));

var _FieldWrapper = _interopRequireDefault(require("./FieldWrapper"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var FieldSelect = function FieldSelect(_ref) {
  var _options$find;

  var name = _ref.name,
      label = _ref.label,
      legend = _ref.legend,
      hint = _ref.hint,
      validate = _ref.validate,
      required = _ref.required,
      initialValue = _ref.initialValue,
      options = _ref.options,
      emptyOption = _ref.emptyOption,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["name", "label", "legend", "hint", "validate", "required", "initialValue", "options", "emptyOption"]);

  var _useField = (0, _useField2["default"])({
    name: name,
    validate: validate,
    required: required,
    initialValue: initialValue
  }),
      error = _useField.error,
      touched = _useField.touched,
      value = _useField.value,
      onChange = _useField.onChange,
      onBlur = _useField.onBlur;

  return /*#__PURE__*/_react["default"].createElement(_FieldWrapper["default"], {
    name: name,
    label: label,
    legend: legend,
    hint: hint,
    error: error
  }, /*#__PURE__*/_react["default"].createElement(_select["default"], {
    name: name,
    onChange: onChange,
    onBlur: onBlur,
    meta: {
      error: error,
      touched: touched
    },
    input: _objectSpread({
      id: name,
      defaultValue: value
    }, rest)
  }, emptyOption && /*#__PURE__*/_react["default"].createElement("option", {
    key: "",
    value: ""
  }, emptyOption), options.map(function (_ref2) {
    var optionLabel = _ref2.label,
        optionValue = _ref2.value;
    return /*#__PURE__*/_react["default"].createElement("option", {
      key: optionValue,
      value: optionValue
    }, optionLabel);
  })), (_options$find = options.find(function (o) {
    return o.value === value;
  })) === null || _options$find === void 0 ? void 0 : _options$find.children);
};

FieldSelect.propTypes = {
  name: _propTypes["default"].string.isRequired,
  label: _propTypes["default"].node,
  legend: _propTypes["default"].node,
  hint: _propTypes["default"].node,
  validate: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].arrayOf(_propTypes["default"].func)]),
  required: _propTypes["default"].string,
  initialValue: _propTypes["default"].string,
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].string.isRequired,
    value: _propTypes["default"].string.isRequired
  })),
  emptyOption: _propTypes["default"].string
};
FieldSelect.defaultProps = {
  validate: null,
  required: null,
  label: null,
  legend: null,
  hint: null,
  initialValue: '',
  options: [],
  emptyOption: 'Please select'
};
var _default = FieldSelect;
exports["default"] = _default;