"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _textArea = require("@govuk-react/text-area");

var _errorText = _interopRequireDefault(require("@govuk-react/error-text"));

var _constants = require("@govuk-react/constants");

var _govukColours = require("govuk-colours");

var _useField2 = _interopRequireDefault(require("../hooks/useField"));

var _FieldWrapper = _interopRequireDefault(require("./FieldWrapper"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  ", "\n  textarea {\n    width: 100%;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledTextareaWrapper = (0, _styledComponents["default"])('div')(_templateObject(), function (props) {
  return props.error && "\n    border-left: ".concat(_constants.BORDER_WIDTH_FORM_ELEMENT_ERROR, " solid ").concat(_govukColours.ERROR_COLOUR, ";\n    margin-right: ").concat(_constants.SPACING.SCALE_3, ";\n    padding-left: ").concat(_constants.SPACING.SCALE_2, ";\n  ");
});

var FieldTextarea = function FieldTextarea(_ref) {
  var name = _ref.name,
      validate = _ref.validate,
      required = _ref.required,
      label = _ref.label,
      legend = _ref.legend,
      hint = _ref.hint,
      initialValue = _ref.initialValue,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["name", "validate", "required", "label", "legend", "hint", "initialValue"]);

  var _useField = (0, _useField2["default"])({
    name: name,
    validate: validate,
    required: required,
    initialValue: initialValue
  }),
      value = _useField.value,
      error = _useField.error,
      touched = _useField.touched,
      onChange = _useField.onChange,
      onBlur = _useField.onBlur;

  return /*#__PURE__*/_react["default"].createElement(_FieldWrapper["default"], {
    name: name,
    label: label,
    legend: legend,
    hint: hint,
    error: error
  }, /*#__PURE__*/_react["default"].createElement(StyledTextareaWrapper, {
    error: error
  }, touched && error && /*#__PURE__*/_react["default"].createElement(_errorText["default"], null, error), /*#__PURE__*/_react["default"].createElement(_textArea.TextAreaField, (0, _extends2["default"])({
    id: name,
    key: name,
    error: touched && error,
    name: name,
    value: value,
    onChange: onChange,
    onBlur: onBlur,
    rows: "5"
  }, rest))));
};

FieldTextarea.propTypes = {
  name: _propTypes["default"].string.isRequired,
  validate: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].arrayOf(_propTypes["default"].func)]),
  required: _propTypes["default"].string,
  label: _propTypes["default"].node,
  legend: _propTypes["default"].node,
  hint: _propTypes["default"].node,
  initialValue: _propTypes["default"].string
};
FieldTextarea.defaultProps = {
  validate: null,
  required: null,
  label: null,
  legend: null,
  hint: null,
  initialValue: ''
};
var _default = FieldTextarea;
exports["default"] = _default;