"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _errorText = _interopRequireDefault(require("@govuk-react/error-text"));

var _constants = require("@govuk-react/constants");

var _govukColours = require("govuk-colours");

var _useField2 = _interopRequireDefault(require("../hooks/useField"));

var _FieldWrapper = _interopRequireDefault(require("./FieldWrapper"));

var _Typeahead = _interopRequireDefault(require("../../typeahead/Typeahead"));

var _useFormContext2 = _interopRequireDefault(require("../hooks/useFormContext"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  ", "\n  textarea {\n    width: 100%;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledWrapper = (0, _styledComponents["default"])('div')(_templateObject(), function (props) {
  return props.error && "\n    border-left: ".concat(_constants.BORDER_WIDTH_FORM_ELEMENT_ERROR, " solid ").concat(_govukColours.ERROR_COLOUR, ";\n    margin-right: ").concat(_constants.SPACING.SCALE_3, ";\n    padding-left: ").concat(_constants.SPACING.SCALE_2, ";\n  ");
});

var FieldTypeahead = function FieldTypeahead(_ref) {
  var name = _ref.name,
      validate = _ref.validate,
      required = _ref.required,
      label = _ref.label,
      legend = _ref.legend,
      hint = _ref.hint,
      initialValue = _ref.initialValue,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["name", "validate", "required", "label", "legend", "hint", "initialValue"]);

  var _useField = (0, _useField2["default"])({
    name: name,
    validate: validate,
    required: required,
    initialValue: initialValue
  }),
      value = _useField.value,
      error = _useField.error,
      touched = _useField.touched,
      onBlur = _useField.onBlur;

  var _useFormContext = (0, _useFormContext2["default"])(),
      setFieldValue = _useFormContext.setFieldValue;

  return /*#__PURE__*/_react["default"].createElement(_FieldWrapper["default"], {
    name: name,
    label: label,
    legend: legend,
    hint: hint,
    error: error
  }, /*#__PURE__*/_react["default"].createElement(StyledWrapper, {
    error: error
  }, touched && error && /*#__PURE__*/_react["default"].createElement(_errorText["default"], null, error), /*#__PURE__*/_react["default"].createElement(_Typeahead["default"], (0, _extends2["default"])({
    inputId: name,
    "aria-label": label || legend,
    onBlur: onBlur,
    onChange: function onChange(newValue) {
      return setFieldValue(name, newValue);
    },
    error: error,
    value: value
  }, rest))));
};

FieldTypeahead.propTypes = _objectSpread(_objectSpread({}, _Typeahead["default"].propTypes), {}, {
  name: _propTypes["default"].string.isRequired,
  validate: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].arrayOf(_propTypes["default"].func)]),
  required: _propTypes["default"].string,
  label: _propTypes["default"].node,
  legend: _propTypes["default"].node,
  hint: _propTypes["default"].string,
  initialValue: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].arrayOf(_propTypes["default"].object)])
});
FieldTypeahead.defaultProps = {
  validate: null,
  required: null,
  label: null,
  legend: null,
  hint: null,
  initialValue: null
};
var _default = FieldTypeahead;
exports["default"] = _default;