"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _visuallyHidden = _interopRequireDefault(require("@govuk-react/visually-hidden"));

var _FieldWrapper = _interopRequireDefault(require("./FieldWrapper"));

var _ButtonLink = _interopRequireDefault(require("../../button-link/ButtonLink"));

var FieldUneditable = function FieldUneditable(_ref) {
  var name = _ref.name,
      label = _ref.label,
      legend = _ref.legend,
      hint = _ref.hint,
      onChangeClick = _ref.onChangeClick,
      children = _ref.children;
  return /*#__PURE__*/_react["default"].createElement(_FieldWrapper["default"], {
    name: name,
    label: label,
    legend: legend,
    hint: hint
  }, children, ' ', onChangeClick && /*#__PURE__*/_react["default"].createElement(_ButtonLink["default"], {
    inline: true,
    type: "button",
    onClick: onChangeClick
  }, "Change ", /*#__PURE__*/_react["default"].createElement(_visuallyHidden["default"], null, label || legend)));
};

FieldUneditable.propTypes = {
  name: _propTypes["default"].string.isRequired,
  label: _propTypes["default"].node,
  legend: _propTypes["default"].node,
  hint: _propTypes["default"].node,
  onChangeClick: _propTypes["default"].func,
  children: _propTypes["default"].node.isRequired
};
FieldUneditable.defaultProps = {
  label: null,
  legend: null,
  hint: null,
  onChangeClick: null
};
var _default = FieldUneditable;
exports["default"] = _default;