"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formGroup = _interopRequireDefault(require("@govuk-react/form-group"));

var _label = _interopRequireDefault(require("@govuk-react/label"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _hintText = _interopRequireDefault(require("@govuk-react/hint-text"));

var _govukColours = require("govuk-colours");

var _constants = require("@govuk-react/constants");

var _paragraph = _interopRequireDefault(require("@govuk-react/paragraph"));

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  padding: 0;\n  margin: 0;\n  padding-bottom: ", ";\n  ", "\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  padding-bottom: ", ";\n  font-weight: ", ";\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  box-sizing: border-box;\n  display: table;\n  white-space: normal;\n  padding: 0;\n  margin: 0;\n  padding-bottom: ", ";\n  * {\n    margin-bottom: ", " !important;\n  }\n  ", "\n  ", "\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  min-width: 0;\n  margin: 0;\n  padding: 0;\n  border: 0;\n  ", "\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledFieldset = (0, _styledComponents["default"])('fieldset')(_templateObject(), function (props) {
  return props.showBorder && "\n    border: 1px solid ".concat(_govukColours.GREY_2, ";\n    padding: ").concat(_constants.SPACING.SCALE_3, ";\n  ");
});
var StyledLegend = (0, _styledComponents["default"])('legend')(_templateObject2(), _constants.SPACING.SCALE_1, _constants.SPACING.SCALE_1, function (props) {
  return props.error && "\n    border-left: ".concat(_constants.BORDER_WIDTH_FORM_ELEMENT_ERROR, " solid ").concat(_govukColours.ERROR_COLOUR, ";\n    margin-right: ").concat(_constants.SPACING.SCALE_3, ";\n    padding-left: ").concat(_constants.SPACING.SCALE_2, ";\n  ");
}, function (props) {
  return props.showBorder && "\n    padding: ".concat(_constants.SPACING.SCALE_2, ";\n    margin-left: -").concat(_constants.SPACING.SCALE_2, ";\n  ");
});
var StyledLabel = (0, _styledComponents["default"])(_label["default"])(_templateObject3(), _constants.SPACING.SCALE_1, _constants.FONT_WEIGHTS.bold);
var StyledHint = (0, _styledComponents["default"])(_hintText["default"])(_templateObject4(), _constants.SPACING.SCALE_2, function (props) {
  return props.error && "\n    border-left: ".concat(_constants.BORDER_WIDTH_FORM_ELEMENT_ERROR, " solid ").concat(_govukColours.ERROR_COLOUR, ";\n    margin-right: ").concat(_constants.SPACING.SCALE_3, ";\n    padding-left: ").concat(_constants.SPACING.SCALE_2, ";\n    padding-bottom: ").concat(_constants.SPACING.SCALE_1, ";\n  ");
});

var FieldInner = function FieldInner(_ref) {
  var legend = _ref.legend,
      error = _ref.error,
      showBorder = _ref.showBorder,
      children = _ref.children;
  return legend ? /*#__PURE__*/_react["default"].createElement(StyledFieldset, {
    showBorder: showBorder
  }, /*#__PURE__*/_react["default"].createElement(StyledLegend, {
    error: error,
    showBorder: showBorder
  }, legend), children) : children;
};

var FieldWrapper = function FieldWrapper(_ref2) {
  var name = _ref2.name,
      label = _ref2.label,
      legend = _ref2.legend,
      hint = _ref2.hint,
      error = _ref2.error,
      showBorder = _ref2.showBorder,
      children = _ref2.children;
  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    id: "field-".concat(name)
  }, /*#__PURE__*/_react["default"].createElement(FieldInner, {
    legend: legend,
    error: error,
    showBorder: showBorder
  }, label && /*#__PURE__*/_react["default"].createElement(StyledLabel, {
    error: error,
    htmlFor: name
  }, label), hint && (showBorder ? /*#__PURE__*/_react["default"].createElement(_paragraph["default"], null, hint) : /*#__PURE__*/_react["default"].createElement(StyledHint, {
    error: error
  }, hint)), children));
};

FieldInner.propTypes = {
  legend: _propTypes["default"].node,
  error: _propTypes["default"].string,
  showBorder: _propTypes["default"].bool,
  children: _propTypes["default"].node
};
FieldInner.defaultProps = {
  legend: null,
  error: null,
  showBorder: false,
  children: null
};
FieldWrapper.propTypes = {
  name: _propTypes["default"].string.isRequired,
  label: _propTypes["default"].node,
  legend: _propTypes["default"].node,
  hint: _propTypes["default"].node,
  error: _propTypes["default"].string,
  showBorder: _propTypes["default"].bool,
  children: _propTypes["default"].node
};
FieldWrapper.defaultProps = {
  label: null,
  legend: null,
  hint: null,
  error: null,
  showBorder: false,
  children: null
};
var _default = FieldWrapper;
exports["default"] = _default;