"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFormContext = _interopRequireDefault(require("../hooks/useFormContext"));

function Form(_ref) {
  var formAttributes = _ref.formAttributes,
      children = _ref.children,
      contextProps = (0, _objectWithoutProperties2["default"])(_ref, ["formAttributes", "children"]);
  return /*#__PURE__*/_react["default"].createElement(_useFormContext["default"].Provider, contextProps, /*#__PURE__*/_react["default"].createElement("form", (0, _extends2["default"])({}, formAttributes, {
    noValidate: true,
    onSubmit: function onSubmit(e) {
      e.preventDefault();
      contextProps.goForward();
    }
  }), children));
}

Form.propTypes = {
  values: _propTypes["default"].object,
  touched: _propTypes["default"].object,
  errors: _propTypes["default"].object,
  fields: _propTypes["default"].objectOf(_propTypes["default"].shape({
    name: _propTypes["default"].string.isRequired,
    initialValue: _propTypes["default"].any,
    validate: _propTypes["default"].arrayOf(_propTypes["default"].func)
  })),
  steps: _propTypes["default"].arrayOf(_propTypes["default"].string),
  currentStep: _propTypes["default"].number,
  isDirty: _propTypes["default"].bool,
  registerField: _propTypes["default"].func.isRequired,
  deregisterField: _propTypes["default"].func.isRequired,
  setFieldValue: _propTypes["default"].func.isRequired,
  setFieldTouched: _propTypes["default"].func.isRequired,
  setFieldError: _propTypes["default"].func.isRequired,
  validateForm: _propTypes["default"].func.isRequired,
  registerStep: _propTypes["default"].func.isRequired,
  deregisterStep: _propTypes["default"].func.isRequired,
  setCurrentStep: _propTypes["default"].func.isRequired,
  goForward: _propTypes["default"].func.isRequired,
  goBack: _propTypes["default"].func.isRequired,
  goToStepByName: _propTypes["default"].func.isRequired,
  getStepIndex: _propTypes["default"].func.isRequired,
  isLastStep: _propTypes["default"].func.isRequired,
  isFirstStep: _propTypes["default"].func.isRequired,
  getFieldState: _propTypes["default"].func.isRequired,
  formAttributes: _propTypes["default"].object,
  children: _propTypes["default"].node
};
Form.defaultProps = {
  values: {},
  touched: {},
  errors: {},
  fields: {},
  steps: [],
  currentStep: 0,
  isDirty: false,
  formAttributes: {},
  children: null
};
var _default = Form;
exports["default"] = _default;