"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _loadingBox = _interopRequireDefault(require("@govuk-react/loading-box"));

var _useForm = _interopRequireDefault(require("../hooks/useForm"));

var _Form = _interopRequireDefault(require("./Form"));

var FormStateful = function FormStateful(_ref) {
  var children = _ref.children,
      formAttributes = _ref.formAttributes,
      contextProps = (0, _objectWithoutProperties2["default"])(_ref, ["children", "formAttributes"]);
  var state = (0, _useForm["default"])(contextProps);

  var renderChildren = function renderChildren() {
    if (typeof children === 'function') {
      return children(state);
    }

    return children;
  };

  return /*#__PURE__*/_react["default"].createElement(_Form["default"], (0, _extends2["default"])({}, formAttributes, state), /*#__PURE__*/_react["default"].createElement(_loadingBox["default"], {
    loading: state.isLoading
  }, renderChildren()));
};

FormStateful.propTypes = {
  initialValues: _propTypes["default"].object,
  initialStep: _propTypes["default"].number,
  onSubmit: _propTypes["default"].func,
  scrollToTop: _propTypes["default"].bool,
  onExit: _propTypes["default"].func,
  formAttributes: _propTypes["default"].object,
  children: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].node]).isRequired
};
FormStateful.defaultProps = {
  initialValues: {},
  initialStep: 0,
  onSubmit: undefined,
  scrollToTop: true,
  onExit: undefined,
  formAttributes: {}
};
var _default = FormStateful;
exports["default"] = _default;