"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _button = _interopRequireDefault(require("@govuk-react/button"));

var _useFormContext2 = _interopRequireDefault(require("../hooks/useFormContext"));

var _ButtonLink = _interopRequireDefault(require("../../button-link/ButtonLink"));

var _FormActions = _interopRequireDefault(require("./FormActions"));

function Step(_ref) {
  var name = _ref.name,
      backButton = _ref.backButton,
      forwardButton = _ref.forwardButton,
      children = _ref.children;

  var _useFormContext = (0, _useFormContext2["default"])(),
      currentStep = _useFormContext.currentStep,
      goBack = _useFormContext.goBack,
      registerStep = _useFormContext.registerStep,
      deregisterStep = _useFormContext.deregisterStep,
      getStepIndex = _useFormContext.getStepIndex,
      isFirstStep = _useFormContext.isFirstStep,
      isLastStep = _useFormContext.isLastStep;

  (0, _react.useEffect)(function () {
    registerStep(name);
    return function () {
      return deregisterStep(name);
    };
  }, [name]);
  var index = getStepIndex(name);

  if (index !== currentStep || index === undefined || currentStep === undefined) {
    return null;
  }

  var renderBackButton = function renderBackButton() {
    if (typeof backButton === 'undefined') {
      return /*#__PURE__*/_react["default"].createElement(_ButtonLink["default"], {
        name: "back",
        onClick: goBack
      }, "Back");
    }

    if (typeof backButton === 'string') {
      return /*#__PURE__*/_react["default"].createElement(_ButtonLink["default"], {
        name: "back",
        onClick: goBack
      }, backButton);
    }

    return backButton;
  };

  var renderForwardButton = function renderForwardButton() {
    if (typeof forwardButton === 'undefined') {
      return /*#__PURE__*/_react["default"].createElement(_button["default"], {
        name: "forward"
      }, isLastStep() ? 'Submit' : 'Continue');
    }

    if (typeof forwardButton === 'string') {
      return /*#__PURE__*/_react["default"].createElement(_button["default"], {
        name: "forward"
      }, forwardButton);
    }

    return forwardButton;
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, typeof children === 'function' ? children() : children, /*#__PURE__*/_react["default"].createElement(_FormActions["default"], null, renderForwardButton(), !isFirstStep() && renderBackButton()));
}

Step.propTypes = {
  name: _propTypes["default"].string.isRequired,
  backButton: _propTypes["default"].node,
  forwardButton: _propTypes["default"].node,
  children: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].node])
};
Step.defaultProps = {
  backButton: undefined,
  forwardButton: undefined,
  children: null
};
var _default = Step;
exports["default"] = _default;