"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = require("react");

var _lodash = require("lodash");

var _useFormContext2 = _interopRequireDefault(require("./useFormContext"));

function useField(_ref) {
  var name = _ref.name,
      _ref$initialValue = _ref.initialValue,
      initialValue = _ref$initialValue === void 0 ? '' : _ref$initialValue,
      _ref$validate = _ref.validate,
      validate = _ref$validate === void 0 ? null : _ref$validate,
      _ref$required = _ref.required,
      required = _ref$required === void 0 ? null : _ref$required;

  var _useFormContext = (0, _useFormContext2["default"])(),
      registerField = _useFormContext.registerField,
      deregisterField = _useFormContext.deregisterField,
      setFieldTouched = _useFormContext.setFieldTouched,
      setFieldValue = _useFormContext.setFieldValue,
      getFieldState = _useFormContext.getFieldState;

  function prepareValidators() {
    var validators = (0, _lodash.castArray)(validate).filter(function (v) {
      return v;
    });

    if (required) {
      validators.unshift(function (value) {
        return (0, _lodash.isEmpty)(value) ? required : null;
      });
    }

    return validators;
  }

  (0, _react.useEffect)(function () {
    registerField({
      name: name,
      initialValue: initialValue,
      validate: prepareValidators()
    });
    return function () {
      deregisterField(name);
    };
  }, [name]);
  var fieldState = getFieldState(name, initialValue);
  return {
    name: name,
    value: fieldState.value,
    error: fieldState.error,
    touched: fieldState.touched,
    onChange: function onChange(e) {
      return setFieldValue(name, e.target.value);
    },
    onBlur: function onBlur() {
      return setFieldTouched(name, true);
    }
  };
}

var _default = useField;
exports["default"] = _default;