"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _lodash = require("lodash");

var _reactUse = require("react-use");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

// Based on react-use/useBeforeUnload but can handle custom handlers (for tests).
function useBeforeUnload(enabled, onExit) {
  (0, _react.useEffect)(function () {
    var handler = function handler(event) {
      event.preventDefault();
      var callbackReturnValue = typeof onExit === 'function' ? onExit() : false;

      if (callbackReturnValue) {
        // eslint-disable-next-line no-param-reassign
        event.returnValue = callbackReturnValue;
      }

      return callbackReturnValue;
    };

    if (enabled) {
      window.addEventListener('beforeunload', handler);
    }

    return function () {
      return window.removeEventListener('beforeunload', handler);
    };
  }, [enabled, onExit]);
}

function useForm() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$initialValues = _ref.initialValues,
      initialValues = _ref$initialValues === void 0 ? {} : _ref$initialValues,
      _ref$initialStep = _ref.initialStep,
      initialStep = _ref$initialStep === void 0 ? 0 : _ref$initialStep,
      onSubmit = _ref.onSubmit,
      _ref$scrollToTop = _ref.scrollToTop,
      scrollToTop = _ref$scrollToTop === void 0 ? true : _ref$scrollToTop,
      onExit = _ref.onExit;

  var _useState = (0, _react.useState)(initialValues),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      values = _useState2[0],
      setValues = _useState2[1];

  var _useState3 = (0, _react.useState)({}),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      touched = _useState4[0],
      setTouched = _useState4[1];

  var _useState5 = (0, _react.useState)({}),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      errors = _useState6[0],
      setErrors = _useState6[1];

  var _useState7 = (0, _react.useState)({}),
      _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
      fields = _useState8[0],
      setFields = _useState8[1];

  var _useState9 = (0, _react.useState)([]),
      _useState10 = (0, _slicedToArray2["default"])(_useState9, 2),
      steps = _useState10[0],
      setSteps = _useState10[1];

  var _useState11 = (0, _react.useState)(initialStep),
      _useState12 = (0, _slicedToArray2["default"])(_useState11, 2),
      currentStep = _useState12[0],
      setCurrentStep = _useState12[1];

  var _useState13 = (0, _react.useState)(false),
      _useState14 = (0, _slicedToArray2["default"])(_useState13, 2),
      isLoading = _useState14[0],
      setIsLoading = _useState14[1];

  var _useState15 = (0, _react.useState)(false),
      _useState16 = (0, _slicedToArray2["default"])(_useState15, 2),
      isSubmitted = _useState16[0],
      setIsSubmitted = _useState16[1];

  var _useState17 = (0, _react.useState)(null),
      _useState18 = (0, _slicedToArray2["default"])(_useState17, 2),
      submissionError = _useState18[0],
      setSubmissionError = _useState18[1];

  var isDirty = !(0, _lodash.isEmpty)(touched) || !(0, _lodash.isEmpty)(values) && !(0, _lodash.isEqual)(values, initialValues);

  var _useState19 = (0, _react.useState)(null),
      _useState20 = (0, _slicedToArray2["default"])(_useState19, 2),
      redirectUrl = _useState20[0],
      setRedirectUrl = _useState20[1];

  var formState = {
    values: values,
    touched: touched,
    errors: errors,
    fields: fields,
    steps: steps,
    currentStep: currentStep,
    isLoading: isLoading,
    isSubmitted: isSubmitted,
    isDirty: isDirty,
    submissionError: submissionError
  };
  useBeforeUnload(isDirty && !isSubmitted && !submissionError && !redirectUrl, onExit);
  (0, _react.useEffect)(function () {
    if (redirectUrl) {
      window.location.assign(redirectUrl);
    }
  }, [redirectUrl]);
  (0, _reactUse.useDeepCompareEffect)(function () {
    if (scrollToTop) {
      window.scrollTo(0, 0);
    }
  }, [currentStep, errors]);

  var getFieldState = function getFieldState(name, initialState) {
    var _values$name;

    return {
      value: (_values$name = values[name]) !== null && _values$name !== void 0 ? _values$name : initialState,
      touched: touched[name] || false,
      error: errors[name] || null
    };
  };

  var validateField = function validateField(name) {
    var field = fields[name];
    var value = values[name];

    if (!field) {
      throw new Error("Field ".concat(name, " does not exist"));
    }

    if (field && 'validate' in field) {
      if (typeof field.validate === 'function') {
        return field.validate(value, name, formState);
      }

      if (Array.isArray(field.validate)) {
        var validationErrors = field.validate.map(function (validator) {
          return validator(value, field, formState);
        }).filter(function (e) {
          return e;
        });
        return validationErrors.length > 0 ? validationErrors[0] : null;
      }
    }

    return null;
  };

  var validateForm = function validateForm() {
    var fieldNames = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var fieldsToValidate = fieldNames.length > 0 ? fieldNames : Object.keys(fields);
    var newErrors = {};
    var newTouched = {};
    fieldsToValidate.forEach(function (name) {
      var error = validateField(name);

      if (error) {
        newErrors[name] = error;
      }

      newTouched[name] = true;
    });
    setErrors(newErrors);
    setTouched(newTouched);
    return newErrors;
  };

  var setFieldValue = function setFieldValue(name, fieldValue) {
    return setValues(function (prevValues) {
      return _objectSpread(_objectSpread({}, prevValues), {}, (0, _defineProperty2["default"])({}, name, fieldValue));
    });
  };

  var setFieldTouched = function setFieldTouched(name, fieldTouched) {
    setTouched(function (prevTouched) {
      return _objectSpread(_objectSpread({}, prevTouched), {}, (0, _defineProperty2["default"])({}, name, fieldTouched));
    });
  };

  var setFieldError = function setFieldError(name, error) {
    return setErrors(function (prevErrors) {
      return _objectSpread(_objectSpread({}, prevErrors), {}, (0, _defineProperty2["default"])({}, name, error));
    });
  };

  var registerField = function registerField(field) {
    return setFields(function (prevFields) {
      var name = field.name,
          initialValue = field.initialValue;

      if (initialValue && values[name] === undefined) {
        setFieldValue(name, initialValue);
      }

      setFieldTouched(name, false);

      if (!(name in prevFields)) {
        return _objectSpread(_objectSpread({}, prevFields), {}, (0, _defineProperty2["default"])({}, name, field));
      }

      return prevFields;
    });
  };

  var deregisterField = function deregisterField(name) {
    setFields(function (prevFields) {
      var newFields = _objectSpread({}, prevFields);

      delete newFields[name];
      return newFields;
    });
    setErrors(function (prevErrors) {
      var newErrors = _objectSpread({}, prevErrors);

      delete newErrors[name];
      return newErrors;
    });
    setTouched(function (prevTouched) {
      var newTouched = _objectSpread({}, prevTouched);

      delete newTouched[name];
      return newTouched;
    });
  };

  var registerStep = function registerStep(name) {
    setSteps(function (prevSteps) {
      if (!prevSteps.includes(name)) {
        var newSteps = (0, _toConsumableArray2["default"])(prevSteps);
        newSteps.push(name);
        return newSteps;
      }

      return prevSteps;
    });
  };

  var deregisterStep = function deregisterStep(name) {
    return setSteps(function (prevSteps) {
      return prevSteps.filter(function (s) {
        return s !== name;
      });
    });
  };

  var isFirstStep = function isFirstStep() {
    return currentStep === 0;
  };

  var isLastStep = function isLastStep() {
    return currentStep === steps.length - 1 || steps.length === 0;
  };

  var submitForm = /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var newRedirectUrl;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              setIsLoading(true);

              if (!(typeof onSubmit === 'function')) {
                _context.next = 6;
                break;
              }

              _context.next = 5;
              return onSubmit(values);

            case 5:
              newRedirectUrl = _context.sent;

            case 6:
              if (newRedirectUrl) {
                setRedirectUrl(newRedirectUrl);
              } else {
                setIsLoading(false);
                setIsSubmitted(true);
              }

              _context.next = 13;
              break;

            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](0);
              setSubmissionError(_context.t0);
              setIsLoading(false);

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 9]]);
    }));

    return function submitForm() {
      return _ref2.apply(this, arguments);
    };
  }();

  var getStepIndex = function getStepIndex(stepName) {
    var index = steps.indexOf(stepName);
    return index !== -1 ? index : null;
  };

  var goForward = /*#__PURE__*/function () {
    var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      var validationErrors;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              validationErrors = validateForm();

              if ((0, _lodash.isEmpty)(validationErrors)) {
                _context2.next = 3;
                break;
              }

              return _context2.abrupt("return");

            case 3:
              if (isLastStep()) {
                _context2.next = 6;
                break;
              }

              setCurrentStep(currentStep + 1);
              return _context2.abrupt("return");

            case 6:
              _context2.next = 8;
              return submitForm();

            case 8:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function goForward() {
      return _ref3.apply(this, arguments);
    };
  }();

  var goBack = function goBack() {
    return setCurrentStep(currentStep - 1);
  };

  var goToStepByName = function goToStepByName(stepName) {
    return setCurrentStep(steps.indexOf(stepName));
  };

  return _objectSpread(_objectSpread({}, formState), {}, {
    registerField: registerField,
    deregisterField: deregisterField,
    setFieldValue: setFieldValue,
    setFieldTouched: setFieldTouched,
    setFieldError: setFieldError,
    getFieldState: getFieldState,
    validateForm: validateForm,
    validateField: validateField,
    registerStep: registerStep,
    deregisterStep: deregisterStep,
    setCurrentStep: setCurrentStep,
    setIsLoading: setIsLoading,
    setIsSubmitted: setIsSubmitted,
    goForward: goForward,
    goBack: goBack,
    goToStepByName: goToStepByName,
    getStepIndex: getStepIndex,
    isLastStep: isLastStep,
    isFirstStep: isFirstStep
  });
}

var _default = useForm;
exports["default"] = _default;