"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _constants = require("@govuk-react/constants");

var _MetadataItem = _interopRequireDefault(require("./MetadataItem"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-size: ", ";\n  line-height: ", ";\n  display: grid;\n\n  & > * {\n    margin-bottom: ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledMetadataWrapper = (0, _styledComponents["default"])('div')(_templateObject(), _constants.FONT_SIZE.SIZE_16, _constants.FONT_SIZE.SIZE_27, _constants.SPACING.SCALE_1);

var Metadata = function Metadata(_ref) {
  var rows = _ref.rows;
  return rows && /*#__PURE__*/_react["default"].createElement(StyledMetadataWrapper, null, rows.map(function (_ref2) {
    var label = _ref2.label,
        value = _ref2.value;
    return /*#__PURE__*/_react["default"].createElement(_MetadataItem["default"], {
      key: label,
      label: label
    }, value);
  }));
};

Metadata.propTypes = {
  rows: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].node,
    value: _propTypes["default"].node
  }))
};
Metadata.defaultProps = {
  rows: null
};
var _default = Metadata;
exports["default"] = _default;