"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _govukColours = require("govuk-colours");

var _constants = require("@govuk-react/constants");

var _link = _interopRequireDefault(require("@govuk-react/link"));

var _computeVisiblePieces = _interopRequireDefault(require("./computeVisiblePieces"));

var _constants2 = require("./constants");

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-weight: bold;\n  font-size: ", ";\n  display: inline-block;\n  padding: ", ";\n  background-color: transparent;\n  line-height: ", ";\n  color: ", ";\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  :link {\n    color: ", ";\n    background-color: transparent;\n  }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-weight: bold;\n  font-size: ", ";\n  display: inline-block;\n  padding: ", " ", ";\n  background-color: ", ";\n  line-height: 1.9em;\n  color: ", ";\n  text-decoration: none;\n\n  :hover {\n    background-color: ", ";\n  }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  display: inline-block;\n\n  & + & {\n    margin-left: ", ";\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  margin: 0;\n  list-style: none;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  text-align: center;\n  line-height: 1;\n  display: flex;\n  justify-content: space-around;\n  padding: ", ";\n\n  ", " {\n    display: block;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledNav = (0, _styledComponents["default"])('nav')(_templateObject(), _constants.SPACING.SCALE_3, _constants.MEDIA_QUERIES.TABLET);
var StyledPaginationList = (0, _styledComponents["default"])('ul')(_templateObject2());
var StyledPaginationPiece = (0, _styledComponents["default"])('li')(_templateObject3(), _constants.SPACING.SCALE_1);
var StyledPaginationLink = (0, _styledComponents["default"])(_link["default"])(_templateObject4(), _constants.FONT_SIZE.SIZE_16, _constants.SPACING.SCALE_1, _constants.SPACING.SCALE_3, _govukColours.GREY_4, _govukColours.LINK_COLOUR, _govukColours.GREY_3);
var StyledActivePaginationLink = (0, _styledComponents["default"])(StyledPaginationLink)(_templateObject5(), _govukColours.TEXT_COLOUR);
var StyledPagesTruncation = (0, _styledComponents["default"])('span')(_templateObject6(), _constants.FONT_SIZE.SIZE_16, _constants.SPACING.SCALE_2, _constants.FONT_SIZE.SIZE_24, _govukColours.GREY_1);

function Pagination(_ref) {
  var totalPages = _ref.totalPages,
      activePage = _ref.activePage,
      onPageClick = _ref.onPageClick,
      getPageUrl = _ref.getPageUrl;
  var visiblePieces = (0, _computeVisiblePieces["default"])(totalPages, activePage);

  if (totalPages < 2) {
    return null;
  }

  return /*#__PURE__*/_react["default"].createElement(StyledNav, {
    "aria-label": "pagination: total ".concat(totalPages, " pages")
  }, /*#__PURE__*/_react["default"].createElement(StyledPaginationList, null, visiblePieces.map(function (_ref2, index) {
    var type = _ref2.type,
        pageNumber = _ref2.pageNumber,
        isActive = _ref2.isActive,
        isDisabled = _ref2.isDisabled;
    var key = "".concat(type, "-").concat(index);

    var onClick = function onClick(event) {
      return onPageClick(pageNumber, event);
    };

    var PageNumberLink = isActive ? StyledActivePaginationLink : StyledPaginationLink;

    if (isDisabled) {
      return null;
    }

    return /*#__PURE__*/_react["default"].createElement(StyledPaginationPiece, {
      key: key
    }, type === _constants2.PAGINATION_PIECE_PREVIOUS && /*#__PURE__*/_react["default"].createElement(StyledPaginationLink, {
      "data-test": "prev",
      onClick: onClick,
      href: getPageUrl(pageNumber)
    }, "Previous"), type === _constants2.PAGINATION_PIECE_ELLIPSIS && /*#__PURE__*/_react["default"].createElement(StyledPagesTruncation, {
      "data-test": "ellipsis"
    }, "\u2026"), type === _constants2.PAGINATION_PIECE_PAGE_NUMBER && /*#__PURE__*/_react["default"].createElement(PageNumberLink, {
      "data-test": isActive ? 'page-number-active' : 'page-number',
      onClick: onClick,
      href: getPageUrl(pageNumber)
    }, pageNumber), type === _constants2.PAGINATION_PIECE_NEXT && /*#__PURE__*/_react["default"].createElement(StyledPaginationLink, {
      "data-test": "next",
      onClick: onClick,
      href: getPageUrl(pageNumber)
    }, "Next"));
  })));
}

Pagination.propTypes = {
  totalPages: _propTypes["default"].number.isRequired,
  activePage: _propTypes["default"].number,
  onPageClick: _propTypes["default"].func,
  getPageUrl: _propTypes["default"].func
};
Pagination.defaultProps = {
  activePage: 1,
  onPageClick: null,
  getPageUrl: function getPageUrl() {
    return '#';
  }
};
var _default = Pagination;
exports["default"] = _default;