"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _constants = require("./constants");

function computeVisiblePieces(numberOfPages, activePage) {
  var maxPageNumbers = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _constants.DEFAULT_MAX_PAGE_NUMBER_LINKS;
  var visiblePieces = [];
  var lowerLimit = activePage;
  var upperLimit = activePage;
  visiblePieces.push({
    type: _constants.PAGINATION_PIECE_PREVIOUS,
    pageNumber: Math.max(1, activePage - 1),
    isDisabled: activePage === 1
  });

  for (var i = 1; i < maxPageNumbers && i < numberOfPages;) {
    if (lowerLimit > 1) {
      lowerLimit -= 1;
      i += 1;
    }

    if (i < maxPageNumbers && upperLimit < numberOfPages) {
      upperLimit += 1;
      i += 1;
    }
  }

  if (lowerLimit > 1) {
    visiblePieces.push({
      type: _constants.PAGINATION_PIECE_PAGE_NUMBER,
      pageNumber: 1,
      isActive: activePage === 1
    });
    visiblePieces.push({
      type: _constants.PAGINATION_PIECE_ELLIPSIS
    });
  }

  for (var _i = lowerLimit; _i <= upperLimit; _i += 1) {
    visiblePieces.push({
      type: _constants.PAGINATION_PIECE_PAGE_NUMBER,
      pageNumber: _i,
      isActive: activePage === _i
    });
  }

  if (activePage < numberOfPages - 2 && numberOfPages > maxPageNumbers) {
    visiblePieces.push({
      type: _constants.PAGINATION_PIECE_ELLIPSIS
    });
    visiblePieces.push({
      type: _constants.PAGINATION_PIECE_PAGE_NUMBER,
      pageNumber: numberOfPages,
      isActive: activePage === numberOfPages
    });
  }

  visiblePieces.push({
    type: _constants.PAGINATION_PIECE_NEXT,
    pageNumber: Math.min(numberOfPages, activePage + 1),
    isDisabled: activePage === numberOfPages
  });
  return visiblePieces;
}

var _default = computeVisiblePieces;
exports["default"] = _default;