"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _lodash = require("lodash");

var _constants = require("@govuk-react/constants");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  padding-right: ", ";\n  width: 30%;\n  font-weight: bold;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  ", " {\n    display: flex;\n    flex-direction: column;\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  padding: ", " 0;\n\n  ", " {\n    display: inline-flex;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledInnerRow = (0, _styledComponents["default"])('div')(_templateObject(), _constants.SPACING.SCALE_2, _constants.MEDIA_QUERIES.TABLET);
var StyledDL = (0, _styledComponents["default"])('dl')(_templateObject2(), _constants.MEDIA_QUERIES.TABLET);
var StyledDT = (0, _styledComponents["default"])('dt')(_templateObject3(), _constants.SPACING.SCALE_4);

var SummaryList = function SummaryList(_ref) {
  var rows = _ref.rows;
  return rows ? /*#__PURE__*/_react["default"].createElement(StyledDL, null, rows.filter(function (r) {
    return !(0, _lodash.isEmpty)(r) && !(0, _lodash.isEmpty)(r.value);
  }).map(function (_ref2) {
    var label = _ref2.label,
        value = _ref2.value;
    return /*#__PURE__*/_react["default"].createElement(StyledInnerRow, {
      key: label
    }, /*#__PURE__*/_react["default"].createElement(StyledDT, null, label), /*#__PURE__*/_react["default"].createElement("dd", null, Array.isArray(value) ? value.join(', ') : value));
  })) : null;
};

SummaryList.propTypes = {
  rows: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].node,
    value: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].arrayOf(_propTypes["default"].node)])
  }))
};
SummaryList.defaultProps = {
  rows: null
};
var _default = SummaryList;
exports["default"] = _default;