"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _table = _interopRequireDefault(require("@govuk-react/table"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = require("lodash");

var _govukColours = require("govuk-colours");

var _lib = require("@govuk-react/lib");

var _constants = require("@govuk-react/constants");

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-size: ", ";\n  line-height: ", ";\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  list-style: none;\n  padding: 0;\n  margin: 0;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  & > tbody th {\n    width: 30%;\n  }\n  & > caption {\n    ", ";\n    margin-bottom: ", ";\n  }\n  & > tbody > tr:first-child {\n    border-top: 1px solid ", ";\n  }\n  & > caption > * {\n    ", ";\n    float: right;\n    margin-left: ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledTable = (0, _styledComponents["default"])(_table["default"])(_templateObject(), _lib.typography.font({
  size: 24,
  weight: 'bold'
}), _constants.SPACING.SCALE_4, _govukColours.GREY_2, _lib.typography.font({
  size: 19,
  weight: 'bold'
}), _constants.SPACING.SCALE_3);
var StyledCellList = (0, _styledComponents["default"])('ul')(_templateObject2());

var SummaryTable = function SummaryTable(_ref) {
  var caption = _ref.caption,
      actions = _ref.actions,
      children = _ref.children,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["caption", "actions", "children"]);
  return /*#__PURE__*/_react["default"].createElement(StyledTable, (0, _extends2["default"])({
    caption: [caption, actions]
  }, rest), children);
};

var StyledTableRow = (0, _styledComponents["default"])(_table["default"].Row)(_templateObject3(), _constants.FONT_SIZE.SIZE_16, _constants.LINE_HEIGHT.SIZE_24);

SummaryTable.Row = function (_ref2) {
  var heading = _ref2.heading,
      children = _ref2.children;

  if ((0, _lodash.isEmpty)(children)) {
    return null;
  }

  var renderChildren = function renderChildren() {
    if (Array.isArray(children)) {
      return /*#__PURE__*/_react["default"].createElement(StyledCellList, null, children.filter(function (c) {
        return c;
      }).map(function (c) {
        return /*#__PURE__*/_react["default"].createElement("li", {
          key: c
        }, c);
      }));
    }

    return children;
  };

  return /*#__PURE__*/_react["default"].createElement(StyledTableRow, null, heading && /*#__PURE__*/_react["default"].createElement(_table["default"].CellHeader, null, heading), /*#__PURE__*/_react["default"].createElement(_table["default"].Cell, null, renderChildren()));
};

SummaryTable.propTypes = {
  caption: _propTypes["default"].string,
  actions: _propTypes["default"].node,
  children: _propTypes["default"].node
};
SummaryTable.defaultProps = {
  caption: null,
  actions: null,
  children: null
};
SummaryTable.Row.propTypes = {
  heading: _propTypes["default"].string,
  children: _propTypes["default"].node
};
SummaryTable.Row.defaultProps = {
  heading: null,
  children: null
};
var _default = SummaryTable;
exports["default"] = _default;