"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactStringReplace = _interopRequireDefault(require("react-string-replace"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _constants = require("@govuk-react/constants");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  font-weight: ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var StyledSpan = (0, _styledComponents["default"])('span')(_templateObject(), _constants.FONT_WEIGHTS.bold);

var Highlighter = function Highlighter(_ref) {
  var _ref$optionLabel = _ref.optionLabel,
      optionLabel = _ref$optionLabel === void 0 ? null : _ref$optionLabel,
      searchStr = _ref.searchStr;
  return optionLabel && (0, _reactStringReplace["default"])(optionLabel, searchStr, function (matchedTxt, i) {
    return /*#__PURE__*/_react["default"].createElement(StyledSpan, {
      key: i
    }, matchedTxt);
  });
};

Highlighter.propTypes = {
  optionLabel: _propTypes["default"].string.isRequired,
  searchStr: _propTypes["default"].string.isRequired
};
var _default = Highlighter;
exports["default"] = _default;