"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.filterOption = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _reactSelect = _interopRequireWildcard(require("react-select"));

var _async = _interopRequireDefault(require("react-select/async"));

var _styles = _interopRequireWildcard(require("./styles"));

var _Highlighter = _interopRequireDefault(require("./Highlighter"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Option = function Option(_ref) {
  var inputValue = _ref.selectProps.inputValue,
      label = _ref.data.label,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["selectProps", "data"]);
  return /*#__PURE__*/_react["default"].createElement(_reactSelect.components.Option, props, /*#__PURE__*/_react["default"].createElement(_Highlighter["default"], {
    searchStr: inputValue,
    optionLabel: label
  }));
};

Option.propTypes = _reactSelect.components.Option.propTypes;

var filterOption = function filterOption(_ref2, query) {
  var _ref2$label = _ref2.label,
      label = _ref2$label === void 0 ? '' : _ref2$label;
  return label.toLowerCase().includes(query.toLowerCase());
};

exports.filterOption = filterOption;

var Typeahead = function Typeahead(_ref3) {
  var options = _ref3.options,
      styles = _ref3.styles,
      components = _ref3.components,
      error = _ref3.error,
      props = (0, _objectWithoutProperties2["default"])(_ref3, ["options", "styles", "components", "error"]);

  var customisedProps = _objectSpread({
    styles: _objectSpread(_objectSpread({}, error ? _styles.errorStyles : _styles["default"]), styles),
    components: {
      Option: Option
    },
    noOptionsMessage: function noOptionsMessage() {
      return 'No options found';
    },
    filterOption: filterOption
  }, props);

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, options ? /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], (0, _extends2["default"])({}, customisedProps, {
    options: options
  })) : /*#__PURE__*/_react["default"].createElement(_async["default"], customisedProps));
};

Typeahead.propTypes = _reactSelect["default"].propTypes;
var _default = Typeahead;
exports["default"] = _default;