"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.errorStyles = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _govukColours = require("govuk-colours");

var _constants = require("@govuk-react/constants");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var defaultStyles = {
  option: function option(styles, _ref) {
    var _objectSpread2;

    var isFocused = _ref.isFocused;
    return _objectSpread(_objectSpread({}, styles), {}, (_objectSpread2 = {
      fontSize: _constants.FONT_SIZE.SIZE_16,
      fontWeight: _constants.FONT_WEIGHTS.regular,
      borderBottom: "1px solid ".concat(_govukColours.BLACK),
      borderRadius: 0,
      paddingTop: _constants.SPACING.SCALE_3,
      paddingBottom: _constants.SPACING.SCALE_3,
      color: isFocused ? _govukColours.WHITE : _govukColours.BLACK,
      backgroundColor: isFocused ? _govukColours.BLUE : _govukColours.WHITE
    }, (0, _defineProperty2["default"])(_objectSpread2, _constants.MEDIA_QUERIES.TABLET, {
      fontSize: _constants.FONT_SIZE.SIZE_19
    }), (0, _defineProperty2["default"])(_objectSpread2, '&:last-of-type', {
      borderBottom: 0
    }), (0, _defineProperty2["default"])(_objectSpread2, '&:hover', {
      cursor: 'pointer'
    }), _objectSpread2));
  },
  noOptionsMessage: function noOptionsMessage(styles) {
    return _objectSpread(_objectSpread({}, styles), {}, {
      fontSize: _constants.FONT_SIZE.SIZE_19
    });
  },
  control: function control(styles, _ref2) {
    var isFocused = _ref2.isFocused;
    return _objectSpread(_objectSpread({}, styles), {}, {
      borderRadius: 0,
      'input:focus': {
        boxShadow: 'none'
      },
      outline: isFocused ? "3px solid ".concat(_govukColours.YELLOW) : styles.outline,
      border: "2px solid ".concat(_govukColours.BLACK),
      '&:hover': {
        border: styles.border
      }
    });
  },
  menu: function menu(styles) {
    return _objectSpread(_objectSpread({}, styles), {}, {
      marginTop: 0,
      borderRadius: 0,
      border: "1px solid ".concat(_govukColours.BLACK),
      borderTop: 0
    });
  },
  placeholder: function placeholder(styles, _ref3) {
    var _ref3$isFocused = _ref3.isFocused,
        isFocused = _ref3$isFocused === void 0 ? false : _ref3$isFocused;
    return _objectSpread(_objectSpread({}, styles), {}, (0, _defineProperty2["default"])({
      fontSize: _constants.FONT_SIZE.SIZE_16,
      color: isFocused ? _govukColours.GREY_2 : _govukColours.BLACK
    }, _constants.MEDIA_QUERIES.TABLET, {
      fontSize: _constants.FONT_SIZE.SIZE_19
    }));
  },
  multiValueLabel: function multiValueLabel(styles) {
    return _objectSpread(_objectSpread({}, styles), {}, {
      backgroundColor: _govukColours.GREY_4
    });
  },
  multiValueRemove: function multiValueRemove(styles) {
    return _objectSpread(_objectSpread({}, styles), {}, {
      backgroundColor: _govukColours.GREY_3,
      '&:hover': {
        backgroundColor: _govukColours.GREY_2,
        cursor: 'pointer'
      }
    });
  }
};

var errorStyles = _objectSpread(_objectSpread({}, defaultStyles), {}, {
  control: function control() {
    return _objectSpread(_objectSpread({}, defaultStyles.control.apply(defaultStyles, arguments)), {}, {
      border: "4px solid ".concat(_govukColours.ERROR_COLOUR)
    });
  }
});

exports.errorStyles = errorStyles;
var _default = defaultStyles;
exports["default"] = _default;