"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _moment = _interopRequireDefault(require("moment"));

var DATE_FORMAT_LONG = 'YYYY-MM-DD';
var DATE_FORMAT_SHORT = 'YYYY-MM';

function padZero(value) {
  var parsedValue = parseInt(value, 10);

  if (Number.isNaN(parsedValue)) {
    return value;
  }

  return parsedValue < 10 ? "0".concat(parsedValue) : parsedValue.toString();
}

function normaliseAndFormatDate(year, month, day) {
  var y = padZero(year);
  var m = padZero(month);
  var yearAndMonth = "".concat(padZero(y), "-").concat(padZero(m));
  return day ? "".concat(yearAndMonth, "-").concat(padZero(day)) : yearAndMonth;
}

var DateUtils = /*#__PURE__*/function () {
  function DateUtils() {
    (0, _classCallCheck2["default"])(this, DateUtils);
  }

  (0, _createClass2["default"])(DateUtils, null, [{
    key: "format",
    value: function format(dateStr) {
      return (0, _moment["default"])(dateStr).format('DD MMM YYYY');
    }
  }, {
    key: "formatWithTime",
    value: function formatWithTime(dateTimeStr) {
      return (0, _moment["default"])(dateTimeStr).format('D MMM YYYY, h:mma');
    }
  }, {
    key: "isShortDateValid",
    value: function isShortDateValid(year, month) {
      return DateUtils.isDateValid(year, month, null, DATE_FORMAT_SHORT);
    }
  }, {
    key: "transformValueForAPI",
    value: function transformValueForAPI(_ref) {
      var year = _ref.year,
          month = _ref.month,
          _ref$day = _ref.day,
          day = _ref$day === void 0 ? 1 : _ref$day;

      if (year && month && day) {
        return normaliseAndFormatDate(year, month, day);
      }

      return null;
    }
  }]);
  return DateUtils;
}();

exports["default"] = DateUtils;
(0, _defineProperty2["default"])(DateUtils, "isDateValid", function (year, month, day) {
  var format = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : DATE_FORMAT_LONG;
  var date = normaliseAndFormatDate(year, month, day);
  return (0, _moment["default"])(date, format, true).isValid();
});